/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_graphsh.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 19:21:06 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

#include <bf_sfx2/app.hxx>
#include <bf_sfx2/objface.hxx>
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <svtools/whiter.hxx>
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #include <bf_svx/grfflt.hxx>
// auto strip #include <bf_svx/grafctrl.hxx>

#include "graphsh.hxx"
#include "bf_sc.hrc"
// auto strip #include "viewdata.hxx"
// auto strip #include "drawview.hxx"
#include "scresid.hxx"
namespace binfilter {

#define ScGraphicShell
#include "scslots.hxx"

#define ITEMVALUE(ItemSet,Id,Cast) ((const Cast&)(ItemSet).Get(Id)).GetValue()


/*N*/ SFX_IMPL_INTERFACE(ScGraphicShell, ScDrawShell, ScResId(SCSTR_GRAPHICSHELL) )
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT|SFX_VISIBILITY_STANDARD|SFX_VISIBILITY_SERVER,
/*N*/ 								ScResId(RID_GRAPHIC_OBJECTBAR) );
/*N*/ 	SFX_POPUPMENU_REGISTRATION( ScResId(RID_POPUP_GRAPHIC) );
/*N*/ 	SFX_OBJECTMENU_REGISTRATION( SID_OBJECTMENU0, ScResId(RID_OBJECTMENU_DRAW) );
/*N*/ }

//STRIP001 TYPEINIT1( ScGraphicShell, ScDrawShell );
//STRIP001 
//STRIP001 ScGraphicShell::ScGraphicShell(ScViewData* pData) :
//STRIP001 	ScDrawShell(pData)
//STRIP001 {
//STRIP001 	SetHelpId(HID_SCSHELL_GRAPHIC);
//STRIP001 	SetName(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("GraphicObject")));
//STRIP001 }
//STRIP001 
//STRIP001 ScGraphicShell::~ScGraphicShell()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void ScGraphicShell::GetAttrState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	ScDrawView* pView = GetViewData()->GetScDrawView();
//STRIP001 
//STRIP001 	if( pView )
//STRIP001 		SvxGrafAttrHelper::GetGrafAttrState( rSet, *pView );
//STRIP001 }
//STRIP001 
//STRIP001 void ScGraphicShell::Execute( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScDrawView* pView = GetViewData()->GetScDrawView();
//STRIP001 
//STRIP001 	if( pView )
//STRIP001 	{
//STRIP001 		SvxGrafAttrHelper::ExecuteGrafAttr( rReq, *pView );
//STRIP001 		Invalidate();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ScGraphicShell::GetFilterState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	ScDrawView* pView = GetViewData()->GetScDrawView();
//STRIP001 	const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 	BOOL bEnable = FALSE;
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() == 1 )
//STRIP001 	{
//STRIP001 		SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 		if( pObj && pObj->ISA( SdrGrafObj ) && ( ( (SdrGrafObj*) pObj )->GetGraphicType() == GRAPHIC_BITMAP ) )
//STRIP001 			bEnable = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !bEnable )
//STRIP001 		SvxGraphicFilter::DisableGraphicFilterSlots( rSet );
//STRIP001 }

//STRIP001 void ScGraphicShell::ExecuteFilter( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScDrawView* pView = GetViewData()->GetScDrawView();
//STRIP001 	const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() == 1 )
//STRIP001 	{
//STRIP001 		SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 		if( pObj && pObj->ISA( SdrGrafObj ) && ( (SdrGrafObj*) pObj )->GetGraphicType() == GRAPHIC_BITMAP )
//STRIP001 		{
//STRIP001 			GraphicObject aFilterObj( ( (SdrGrafObj*) pObj )->GetGraphicObject() );
//STRIP001 
//STRIP001 			if( SVX_GRAPHICFILTER_ERRCODE_NONE == 
//STRIP001 				SvxGraphicFilter::ExecuteGrfFilterSlot( rReq, aFilterObj ) )
//STRIP001 			{
//STRIP001 				SdrPageView* pPageView = pView->GetPageViewPvNum( 0 );
//STRIP001 
//STRIP001 				if( pPageView )
//STRIP001 				{
//STRIP001 					SdrGrafObj*	pFilteredObj = (SdrGrafObj*) pObj->Clone();
//STRIP001 					String		aStr( pView->GetMarkDescription() );
//STRIP001 
//STRIP001 					aStr.Append( sal_Unicode(' ') );
//STRIP001 					aStr.Append( String( ScResId( SCSTR_UNDO_GRAFFILTER ) ) );
//STRIP001 					pView->BegUndo( aStr );
//STRIP001 					pFilteredObj->SetGraphicObject( aFilterObj );
//STRIP001 					pView->ReplaceObject( pObj, *pPageView, pFilteredObj );
//STRIP001 					pView->EndUndo();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	Invalidate();
//STRIP001 }

}
