/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tpsubt.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 20:24:05 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef SC_TPSUBT_HXX
#define SC_TPSUBT_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _SVX_CHECKLBX_HXX //autogen
#include <bf_svx/checklbx.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef SC_SCGLOB_HXX
#include "global.hxx"
#endif
namespace binfilter {

//------------------------------------------------------------------------

#define SC_MAXFIELDS	200

class ScViewData;
class ScDocument;

//========================================================================
// Gruppenseiten: Basisklasse

//STRIP001 class ScTpSubTotalGroup : public SfxTabPage
//STRIP001 {
//STRIP001 protected:
//STRIP001 			ScTpSubTotalGroup( Window* pParent, USHORT nResId,
//STRIP001 							   const SfxItemSet& rArgSet );
//STRIP001 
//STRIP001 public:
//STRIP001 	virtual ~ScTpSubTotalGroup();
//STRIP001 
//STRIP001 	static USHORT*	GetRanges		();
//STRIP001 	BOOL			DoReset			( USHORT			nGroupNo,
//STRIP001 									  const SfxItemSet&	rArgSet  );
//STRIP001 	BOOL			DoFillItemSet	( USHORT		nGroupNo,
//STRIP001 									  SfxItemSet&	rArgSet  );
//STRIP001 protected:
//STRIP001 	FixedText		aFtGroup;
//STRIP001 	ListBox			aLbGroup;
//STRIP001 	FixedText		aFtColumns;
//STRIP001 	SvxCheckListBox	aLbColumns;
//STRIP001 	FixedText		aFtFunctions;
//STRIP001 	ListBox			aLbFunctions;
//STRIP001 	const String	aStrNone;
//STRIP001 	const String	aStrColumn;
//STRIP001 
//STRIP001 	ScViewData*				pViewData;
//STRIP001 	ScDocument*				pDoc;
//STRIP001 
//STRIP001 	const USHORT			nWhichSubTotals;
//STRIP001 	const ScSubTotalParam&	rSubTotalData;
//STRIP001 	USHORT					nFieldArr[SC_MAXFIELDS];
//STRIP001 	const USHORT			nFieldCount;
//STRIP001 
//STRIP001 private:
//STRIP001 	void 			Init			();
//STRIP001 	void 			FillListBoxes	();
//STRIP001 	ScSubTotalFunc	LbPosToFunc		( USHORT nPos );
//STRIP001 	USHORT			FuncToLbPos		( ScSubTotalFunc eFunc );
//STRIP001 	USHORT			GetFieldSelPos	( USHORT nField );
//STRIP001 
//STRIP001 	// Handler ------------------------
//STRIP001 	DECL_LINK( SelectHdl, ListBox * );
//STRIP001 	DECL_LINK( CheckHdl, ListBox * );
//STRIP001 };

//------------------------------------------------------------------------

//STRIP001 class ScTpSubTotalGroup1 : public ScTpSubTotalGroup
//STRIP001 {
//STRIP001 protected:
//STRIP001 			ScTpSubTotalGroup1( Window*				 pParent,
//STRIP001 								const SfxItemSet&	 rArgSet );
//STRIP001 
//STRIP001 public:
//STRIP001 	virtual ~ScTpSubTotalGroup1();
//STRIP001 
//STRIP001 	static	SfxTabPage*	Create		( Window*				pParent,
//STRIP001 									  const SfxItemSet& 	rArgSet );
//STRIP001 	virtual	BOOL		FillItemSet	( SfxItemSet& rArgSet );
//STRIP001 	virtual	void		Reset		( const SfxItemSet& rArgSet );
//STRIP001 };

//------------------------------------------------------------------------

//STRIP001 class ScTpSubTotalGroup2 : public ScTpSubTotalGroup
//STRIP001 {
//STRIP001 protected:
//STRIP001 			ScTpSubTotalGroup2( Window*				 pParent,
//STRIP001 								const SfxItemSet&	 rArgSet );
//STRIP001 
//STRIP001 public:
//STRIP001 	virtual ~ScTpSubTotalGroup2();
//STRIP001 
//STRIP001 	static	SfxTabPage*	Create		( Window*				pParent,
//STRIP001 									  const SfxItemSet& 	rArgSet );
//STRIP001 	virtual	BOOL		FillItemSet	( SfxItemSet& rArgSet );
//STRIP001 	virtual	void		Reset		( const SfxItemSet& rArgSet );
//STRIP001 };

//------------------------------------------------------------------------

//STRIP001 class ScTpSubTotalGroup3 : public ScTpSubTotalGroup
//STRIP001 {
//STRIP001 protected:
//STRIP001 			ScTpSubTotalGroup3( Window*				 pParent,
//STRIP001 								const SfxItemSet&	 rArgSet );
//STRIP001 
//STRIP001 public:
//STRIP001 	virtual ~ScTpSubTotalGroup3();
//STRIP001 
//STRIP001 	static	SfxTabPage*	Create		( Window*				pParent,
//STRIP001 									  const SfxItemSet& 	rArgSet );
//STRIP001 	virtual	BOOL		FillItemSet	( SfxItemSet& rArgSet );
//STRIP001 	virtual	void		Reset		( const SfxItemSet& rArgSet );
//STRIP001 };

//========================================================================
// Optionen:

//STRIP001 class ScTpSubTotalOptions : public SfxTabPage
//STRIP001 {
//STRIP001 protected:
//STRIP001 			ScTpSubTotalOptions( Window*			 pParent,
//STRIP001 								  const SfxItemSet&  rArgSet );
//STRIP001 
//STRIP001 public:
//STRIP001 	virtual ~ScTpSubTotalOptions();
//STRIP001 
//STRIP001 	static USHORT*		GetRanges	();
//STRIP001 	static SfxTabPage*	Create		( Window*				pParent,
//STRIP001 									  const SfxItemSet& 	rArgSet );
//STRIP001 	virtual	BOOL		FillItemSet	( SfxItemSet& rArgSet );
//STRIP001 	virtual	void		Reset		( const SfxItemSet& rArgSet );
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine   aFlGroup;
//STRIP001 	CheckBox	aBtnPagebreak;
//STRIP001 	CheckBox	aBtnCase;
//STRIP001 	CheckBox	aBtnSort;
//STRIP001     FixedLine   aFlSort;
//STRIP001 	RadioButton	aBtnAscending;
//STRIP001 	RadioButton	aBtnDescending;
//STRIP001 	CheckBox	aBtnFormats;
//STRIP001 	CheckBox	aBtnUserDef;
//STRIP001 	ListBox		aLbUserDef;
//STRIP001 
//STRIP001 	ScViewData*				pViewData;
//STRIP001 	ScDocument*				pDoc;
//STRIP001 	const USHORT			nWhichSubTotals;
//STRIP001 	const ScSubTotalParam&	rSubTotalData;
//STRIP001 
//STRIP001 private:
//STRIP001 	void Init					();
//STRIP001 	void FillUserSortListBox	();
//STRIP001 
//STRIP001 	// Handler ------------------------
//STRIP001 	DECL_LINK( CheckHdl, CheckBox * );
//STRIP001 };



} //namespace binfilter
#endif // SC_TPSORT_HXX

