/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sch_dlggraut.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 22:19:05 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#define OFFSET_PYRAMID 1000
#define OFFSET_ROUND   2000
#define OFFSET_CONE    3000
// TOOLS
#include <bf_sfx2/sfxsids.hrc>
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFXNEW_HXX //autogen
#include <bf_sfx2/new.hxx>
#endif


#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS
#define ITEMID_CHARTTEXTORDER	SCHATTR_TEXT_ORDER
#define ITEMID_CHARTTEXTORIENT	SCHATTR_TEXT_ORIENT
#define ITEMID_DOUBLE			0
#define ITEMID_CHARTSTYLE   CHATTR_DIAGRAM_STYLE
#ifndef _SVX_CHRTITEM_HXX //autogen
#include <bf_svx/chrtitem.hxx>
#endif
#include "memchrt.hxx"

#include "strings.hrc"
#include "res_bmp.hrc"
#include "schresid.hxx"
#include "docshell.hxx"
#include "glob.hrc"
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#include "dlggraut.hrc"
#include "dlggraut.hxx"
#include "chmod3d.hxx"
#include "chaxis.hxx"

// for high contrast images
#include "res_hc_bmp.hrc"
namespace binfilter {

#define	CHARTTYPE_PAGE			0
#define	CHARTVARIANT_PAGE		1
#define	CHARTDETAILS_PAGE		2

//STRIP001 DBG_NAME( SchDiagramAutoPilotDlg )
//STRIP001 
//STRIP001 DECLARE_LIST( SchControlList, Control* )//STRIP008 ;
//STRIP001 
//STRIP001 
//STRIP001 // macro for selecting a normal or high contrast bitmap the stack variable
//STRIP001 // bIsHighContrast must exist and reflect the correct state
//STRIP001 
//STRIP001 #define SELECT_BITMAP(name) Bitmap( SchResId( bIsHighContrast ? name ## _HC : name ))
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 
//STRIP001 SchDiagramAutoPilotDlg::SchDiagramAutoPilotDlg( Window* pParent,
//STRIP001 												SchMemChart& rData,
//STRIP001 												const SfxItemSet& rInAttrs,
//STRIP001 												SfxItemSet& rOutAttrs,
//STRIP001 												BOOL bPrePage )
//STRIP001 
//STRIP001 		: ModalDialog( pParent, SchResId( DLG_CHART_WIZ ) ),
//STRIP001 
//STRIP001           pButtonList( NULL ),
//STRIP001           pDocSh( NULL ),
//STRIP001 		  pOutSet( &rOutAttrs ),
//STRIP001           pDoc( NULL ),
//STRIP001 		  bStored( FALSE ),
//STRIP001           eLegendPos( CHLEGEND_RIGHT ),
//STRIP001           pOriginalData( NULL ),
//STRIP001           pReducedData( NULL ),
//STRIP001 		  nCurPageNr( 0 ),
//STRIP001 		  bHasPrePage( bPrePage ),
//STRIP001           bNoText( TRUE ),
//STRIP001 //           bXAxisChanged( FALSE ),
//STRIP001 //           bYAxisChanged( FALSE ),
//STRIP001           bReducedData( FALSE ),
//STRIP001           bShowMainTitle( FALSE ),
//STRIP001           bShowSubTitle( FALSE ),
//STRIP001           bShowXAxisTitle( FALSE ),
//STRIP001           bShowYAxisTitle( FALSE ),
//STRIP001           bShowZAxisTitle( FALSE ),
//STRIP001           bShowXDescr( FALSE ),
//STRIP001           bShowYDescr( FALSE ),
//STRIP001           bShowZDescr( FALSE ),
//STRIP001           bShowLegend( FALSE ),
//STRIP001 
//STRIP001           nShapeType( CHART_SHAPE3D_ANY ),
//STRIP001 		  bYAutoOrigin( FALSE ),
//STRIP001 
//STRIP001           // page 1
//STRIP001 		  pFT_1_CHARTTYPE( NULL ),
//STRIP001           pCT_1_CHARTTYPE( NULL ),
//STRIP001 
//STRIP001           // page 2
//STRIP001           pFT_2_CHARTVARIANT( NULL ),
//STRIP001           pCT_2_CHARTVARIANT( NULL ),
//STRIP001           pCB_2_XGRID( NULL ),
//STRIP001           pCB_2_YGRID( NULL ),
//STRIP001           pCB_2_ZGRID( NULL ),
//STRIP001           pFL_2_GRID( NULL ),
//STRIP001 
//STRIP001           // page 3
//STRIP001           pFL_3_DISPLAY( NULL ),  
//STRIP001           pCB_3_TEXTTITLE( NULL ),
//STRIP001           pET_3_TEXTTITLE( NULL ),
//STRIP001           pCB_3_LEGEND( NULL ),
//STRIP001           pFT_3_AXES( NULL ),
//STRIP001           pCB_3_XTEXT( NULL ),
//STRIP001           pET_3_TEXTRUBRIK( NULL ),
//STRIP001           pCB_3_YTEXT( NULL ),
//STRIP001           pET_3_TEXTSIZE( NULL ),
//STRIP001           pCB_3_ZTEXT( NULL ),
//STRIP001           pET_3_TEXTSECOND( NULL ),
//STRIP001 
//STRIP001           // all pages
//STRIP001           pCT_PREVIEW   ( NULL ),
//STRIP001           aFL_HORZLINE	( this, ResId( FL_HORZLINE ) ),
//STRIP001 		  aCB_NOTEXT    ( this, ResId( CB_DONTSHOW ) ),
//STRIP001 		  aFT_DATAROWS	( this, ResId( FT_DATAROWS ) ),
//STRIP001 		  aRB_DATAROWS	( this, ResId( RB_DATAROWS ) ),
//STRIP001 		  aRB_DATACOLS	( this, ResId( RB_DATACOLS ) ),
//STRIP001 		  aPB_HELP		( this, ResId( PB_HELP ) ),
//STRIP001 		  aPB_CANCEL	( this, ResId( PB_CANCEL ) ),
//STRIP001 		  aPB_PREV		( this, ResId( PB_PREV ) ),
//STRIP001 		  aPB_NEXT		( this, ResId( PB_NEXT ) ),
//STRIP001 		  aPB_EXECUTE	( this, ResId( PB_EXECUTE ) )
//STRIP001 {
//STRIP001 	//Dieser ctor: Calc->Einfuegen
//STRIP001 
//STRIP001 	DBG_CTOR( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	pDocSh = new SchChartDocShell(SFX_CREATE_MODE_PREVIEW);
//STRIP001 	pDocSh->DoInitNew(NULL);
//STRIP001 
//STRIP001 	//	pTmp->SetVisArea(Rectangle(Point(0, 0), ));
//STRIP001 
//STRIP001 	SchChartDocShell &rMyDoc = (SchChartDocShell &)*pDocSh;
//STRIP001 	pDoc = &rMyDoc.GetDoc();
//STRIP001 
//STRIP001 	pDoc->SetChartStatusFlag( CHS_USER_NOQUERY );	// #56439#
//STRIP001 
//STRIP001 	if (pDoc->GetPageCount() == 0L)//#49318#
//STRIP001 	{
//STRIP001 		// Seite einfuegen
//STRIP001 		BOOL bChanged = pDoc->IsChanged();
//STRIP001 		SdrPage* pPage = pDoc->AllocPage(FALSE);
//STRIP001 		pPage->SetSize(Size(8000, 7000));
//STRIP001 		pDoc->InsertPage(pPage);
//STRIP001 		StoreTextSettings();
//STRIP001 		pDoc->SetSwitchData(TRUE);//default des Piloten
//STRIP001 		SetTextSettings(FALSE); //Alle Beschriftungen aus ist der default
//STRIP001 		pDoc->BuildChart(FALSE);
//STRIP001 		pDoc->SetChanged(bChanged);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		StoreTextSettings();
//STRIP001 		SetTextSettings(FALSE); //Alle Beschriftungen aus ist der default
//STRIP001 		pDoc->BuildChart(FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!rData.GetMainTitle ().Len ()) rData.SetMainTitle (String (SchResId (STR_TITLE_MAIN)));
//STRIP001 	if (!rData.GetSubTitle ().Len ())  rData.SetSubTitle (String (SchResId (STR_TITLE_SUB)));
//STRIP001 	if (!rData.GetXAxisTitle ().Len ())rData.SetXAxisTitle (String (SchResId (STR_DIAGRAM_TITLE_X_AXIS)));
//STRIP001 	if (!rData.GetYAxisTitle ().Len ())rData.SetYAxisTitle (String (SchResId (STR_DIAGRAM_TITLE_Y_AXIS)));
//STRIP001 	if (!rData.GetZAxisTitle ().Len ())rData.SetZAxisTitle (String (SchResId (STR_DIAGRAM_TITLE_Z_AXIS)));
//STRIP001 
//STRIP001 
//STRIP001 	//MemChart mu?evtl. reduziert werden
//STRIP001 	pDoc->SetChartData (*(ReduceData(rData)));
//STRIP001 
//STRIP001 	pDoc->PutAttr(rInAttrs);
//STRIP001 
//STRIP001 	pCT_PREVIEW = new SfxPreviewWin( this, ResId( CT_PREVIEW ), pDocSh );
//STRIP001 
//STRIP001 	//	Switch from 3D border to a flat black lined border.
//STRIP001 	pCT_PREVIEW->SetBorderStyle (WINDOW_BORDER_MONO);
//STRIP001 
//STRIP001 	pCT_PREVIEW->Hide();
//STRIP001 
//STRIP001 	construct( !pDoc->IsSwitchData());
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 
//STRIP001 SchDiagramAutoPilotDlg::SchDiagramAutoPilotDlg( Window * pParent,
//STRIP001 												SfxObjectShellLock& rDocShellRef )
//STRIP001 
//STRIP001 		: ModalDialog( pParent, SchResId( DLG_CHART_WIZ ) ),
//STRIP001 
//STRIP001           pButtonList( NULL ),
//STRIP001           pDocSh( NULL ),
//STRIP001 		  pOutSet( NULL ),
//STRIP001           pDoc( NULL ),
//STRIP001 		  bStored( FALSE ),
//STRIP001           eLegendPos( CHLEGEND_RIGHT ),
//STRIP001           pOriginalData( NULL ),
//STRIP001           pReducedData( NULL ),
//STRIP001 		  nCurPageNr( 0 ),
//STRIP001 		  bHasPrePage( FALSE ),
//STRIP001           bNoText( TRUE ),
//STRIP001 //           bXAxisChanged( FALSE ),
//STRIP001 //           bYAxisChanged( FALSE ),
//STRIP001           bReducedData( FALSE ),
//STRIP001           bShowMainTitle( FALSE ),
//STRIP001           bShowSubTitle( FALSE ),
//STRIP001           bShowXAxisTitle( FALSE ),
//STRIP001           bShowYAxisTitle( FALSE ),
//STRIP001           bShowZAxisTitle( FALSE ),
//STRIP001           bShowXDescr( FALSE ),
//STRIP001           bShowYDescr( FALSE ),
//STRIP001           bShowZDescr( FALSE ),
//STRIP001           bShowLegend( FALSE ),
//STRIP001 
//STRIP001           nShapeType( CHART_SHAPE3D_ANY ),
//STRIP001 		  bYAutoOrigin( FALSE ),
//STRIP001 
//STRIP001           // page 1
//STRIP001 		  pFT_1_CHARTTYPE( NULL ),
//STRIP001           pCT_1_CHARTTYPE( NULL ),
//STRIP001 
//STRIP001           // page 2
//STRIP001           pFT_2_CHARTVARIANT( NULL ),
//STRIP001           pCT_2_CHARTVARIANT( NULL ),
//STRIP001           pCB_2_XGRID( NULL ),
//STRIP001           pCB_2_YGRID( NULL ),
//STRIP001           pCB_2_ZGRID( NULL ),
//STRIP001           pFL_2_GRID( NULL ),
//STRIP001 
//STRIP001           // page 3
//STRIP001           pFL_3_DISPLAY( NULL ),  
//STRIP001           pCB_3_TEXTTITLE( NULL ),
//STRIP001           pET_3_TEXTTITLE( NULL ),
//STRIP001           pCB_3_LEGEND( NULL ),
//STRIP001           pFT_3_AXES( NULL ),
//STRIP001           pCB_3_XTEXT( NULL ),
//STRIP001           pET_3_TEXTRUBRIK( NULL ),
//STRIP001           pCB_3_YTEXT( NULL ),
//STRIP001           pET_3_TEXTSIZE( NULL ),
//STRIP001           pCB_3_ZTEXT( NULL ),
//STRIP001           pET_3_TEXTSECOND( NULL ),
//STRIP001 
//STRIP001           // all pages
//STRIP001           pCT_PREVIEW   ( NULL ),
//STRIP001           aFL_HORZLINE	( this, ResId( FL_HORZLINE ) ),
//STRIP001 		  aCB_NOTEXT    ( this, ResId( CB_DONTSHOW ) ),
//STRIP001 		  aFT_DATAROWS	( this, ResId( FT_DATAROWS ) ),
//STRIP001 		  aRB_DATAROWS	( this, ResId( RB_DATAROWS ) ),
//STRIP001 		  aRB_DATACOLS	( this, ResId( RB_DATACOLS ) ),
//STRIP001 		  aPB_HELP		( this, ResId( PB_HELP ) ),
//STRIP001 		  aPB_CANCEL	( this, ResId( PB_CANCEL ) ),
//STRIP001 		  aPB_PREV		( this, ResId( PB_PREV ) ),
//STRIP001 		  aPB_NEXT		( this, ResId( PB_NEXT ) ),
//STRIP001 		  aPB_EXECUTE	( this, ResId( PB_EXECUTE ) )
//STRIP001 {
//STRIP001 	DBG_CTOR( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	//Dieser ctor wenn APilot aus Chart heraus aufgerufen (Fehler in Textgroesse)
//STRIP001 
//STRIP001 	pDocSh = rDocShellRef;
//STRIP001 	SchChartDocShell &rMyDoc = (SchChartDocShell &)*pDocSh;
//STRIP001 	pDoc = &rMyDoc.GetDoc();
//STRIP001 
//STRIP001 	StoreTextSettings();
//STRIP001 	SetTextSettings(FALSE);
//STRIP001 
//STRIP001 	pDoc->SetChartStatusFlag( CHS_USER_NOQUERY );	// #56439#
//STRIP001 
//STRIP001     // Daten aus dem Document holen und evtl. reduzieren
//STRIP001 	if(!pDoc->ChangeChartData(*ReduceData(*pDoc->GetChartData()),FALSE))
//STRIP001 		BuildChart();
//STRIP001 
//STRIP001 	pCT_PREVIEW = new SfxPreviewWin( this, ResId( CT_PREVIEW ), rDocShellRef ),
//STRIP001 	pCT_PREVIEW->Hide();
//STRIP001 
//STRIP001 	construct( !pDoc->IsSwitchData() );
//STRIP001 }
//STRIP001 
//STRIP001 // ================================================================================
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::construct(BOOL bDataInRows)
//STRIP001 {
//STRIP001 	if(pDoc)
//STRIP001 	{
//STRIP001 		pDoc->SetAutoPilot(this);						// #46895#
//STRIP001 	}
//STRIP001 
//STRIP001 	eLegendPos=CHLEGEND_RIGHT;
//STRIP001 
//STRIP001 	MapMode aMap(MAP_100TH_MM);
//STRIP001 
//STRIP001 	pCT_PREVIEW->SetMapMode(aMap);
//STRIP001 
//STRIP001 	ScalePreview();
//STRIP001 
//STRIP001 	aStrTitle = GetText();
//STRIP001 
//STRIP001 	int		i=0;
//STRIP001   	SchControlList*	pControlList=0;
//STRIP001 
//STRIP001 	for( i=0 ; i<SCH_MAX_PAGES ; i++ )
//STRIP001 		arrPage[i] = new SchControlList;
//STRIP001 
//STRIP001 	//----- Page 1 ---------------
//STRIP001 	pControlList = arrPage[CHARTTYPE_PAGE];
//STRIP001 	pControlList->Insert(
//STRIP001 		pFT_1_CHARTTYPE = new FixedText( this, ResId( FT_1_CHARTTYPE ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pCT_1_CHARTTYPE = new ValueSet( this, ResId( CT_1_CHARTTYPE ) ), LIST_APPEND );
//STRIP001 
//STRIP001 	//----- Page 2 ---------------
//STRIP001 	pControlList = arrPage[CHARTVARIANT_PAGE];
//STRIP001 	pControlList->Insert(
//STRIP001 		pFT_2_CHARTVARIANT = new FixedText( this, ResId( FT_2_CHARTVARIANT ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pCT_2_CHARTVARIANT = new ValueSet( this, ResId( CT_2_CHARTVARIANT ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_2_XGRID = new CheckBox( this, ResId( CB_2_XGRID ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_2_YGRID = new CheckBox( this, ResId( CB_2_YGRID ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_2_ZGRID = new CheckBox( this, ResId( CB_2_ZGRID ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pFL_2_GRID = new FixedLine( this, ResId( FL_2_GRID ) ), LIST_APPEND );
//STRIP001 
//STRIP001 	//----- Page 3 ---------------
//STRIP001 	pControlList = arrPage[CHARTDETAILS_PAGE];
//STRIP001 	pControlList->Insert(
//STRIP001 		pFL_3_DISPLAY = new FixedLine( this, ResId( FL_3_DISPLAY ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_3_TEXTTITLE = new CheckBox( this, ResId( CB_3_TEXTTITLE ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pET_3_TEXTTITLE = new Edit( this, ResId( ET_3_TEXTTITLE ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001         pCB_3_LEGEND = new CheckBox( this, ResId( CB_3_LEGEND ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pFT_3_AXES = new FixedText( this, ResId( FT_3_AXES ) ), LIST_APPEND );
//STRIP001 
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_3_XTEXT = new CheckBox( this, ResId( CB_3_XTEXT ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pET_3_TEXTRUBRIK = new Edit( this, ResId( ET_3_TEXTRUBRIK ) ), LIST_APPEND );
//STRIP001 
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_3_YTEXT = new CheckBox( this, ResId( CB_3_YTEXT ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pET_3_TEXTSIZE = new Edit( this, ResId( ET_3_TEXTSIZE ) ), LIST_APPEND );
//STRIP001 
//STRIP001 	pControlList->Insert(
//STRIP001 		pCB_3_ZTEXT = new CheckBox( this, ResId( CB_3_ZTEXT ) ), LIST_APPEND );
//STRIP001 	pControlList->Insert(
//STRIP001 		pET_3_TEXTSECOND = new Edit( this, ResId( ET_3_TEXTSECOND ) ), LIST_APPEND );
//STRIP001 
//STRIP001 	SetCurrentPage( CHARTTYPE_PAGE );
//STRIP001 
//STRIP001 	//---------------------------------------------------------------------------------
//STRIP001 	pCB_3_TEXTTITLE->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 	pET_3_TEXTTITLE->SetLoseFocusHdl(LINK(this,SchDiagramAutoPilotDlg,EditLoseFocusHdl));
//STRIP001 	pET_3_TEXTRUBRIK->SetLoseFocusHdl(LINK(this,SchDiagramAutoPilotDlg,EditLoseFocusHdl));
//STRIP001 	pET_3_TEXTSIZE->SetLoseFocusHdl(LINK(this,SchDiagramAutoPilotDlg,EditLoseFocusHdl));
//STRIP001 	pET_3_TEXTSECOND->SetLoseFocusHdl(LINK(this,SchDiagramAutoPilotDlg,EditLoseFocusHdl));
//STRIP001 
//STRIP001 	aRB_DATAROWS.SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,RadioButtonClickHdl) );
//STRIP001 	aRB_DATACOLS.SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,RadioButtonClickHdl) );
//STRIP001 	aRB_DATAROWS.Check( bDataInRows );
//STRIP001 	aRB_DATACOLS.Check(!bDataInRows );
//STRIP001 
//STRIP001     pCB_3_LEGEND->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001     pCB_3_LEGEND->Check( FALSE );
//STRIP001 
//STRIP001 	pCB_3_XTEXT->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 	pCB_3_YTEXT->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 	pCB_3_ZTEXT->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 
//STRIP001 	//----------- Chart Haupgruppe-----------------------------------------------------
//STRIP001 	pCT_1_CHARTTYPE->SetStyle(pCT_1_CHARTTYPE->GetStyle() |
//STRIP001 		WB_ITEMBORDER | WB_DOUBLEBORDER | WB_NAMEFIELD | WB_VSCROLL | WB_FLATVALUESET | WB_3DLOOK);
//STRIP001 	pCT_1_CHARTTYPE->SetColCount(4);
//STRIP001 	pCT_1_CHARTTYPE->SetLineCount(2);
//STRIP001 	pCT_1_CHARTTYPE->SetExtraSpacing(2);
//STRIP001 	pCT_1_CHARTTYPE->SetSelectHdl(LINK(this, SchDiagramAutoPilotDlg, SelectChartTypeHdl));
//STRIP001 
//STRIP001     FillValueSets();
//STRIP001     
//STRIP001     pCT_2_CHARTVARIANT->SetStyle(pCT_2_CHARTVARIANT->GetStyle() |
//STRIP001 		WB_ITEMBORDER | WB_DOUBLEBORDER | WB_NAMEFIELD | WB_VSCROLL | WB_FLATVALUESET | WB_3DLOOK);
//STRIP001 	pCT_2_CHARTVARIANT->SetColCount(4);
//STRIP001 	pCT_2_CHARTVARIANT->SetLineCount(1);
//STRIP001 	pCT_2_CHARTVARIANT->SetExtraSpacing(2);
//STRIP001 	pCT_2_CHARTVARIANT->SetSelectHdl(LINK(this, SchDiagramAutoPilotDlg, SelectChartVariantHdl ));
//STRIP001 
//STRIP001 	InitFromModel();
//STRIP001 
//STRIP001 
//STRIP001 	pCB_2_XGRID->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 	pCB_2_YGRID->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 	pCB_2_ZGRID->SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,CheckBoxClickHdl) );
//STRIP001 
//STRIP001 	//----------- Allgemein--------------------------------------------------------
//STRIP001 	aPB_EXECUTE.SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,ExecuteClickHdl) );
//STRIP001 	aPB_PREV.SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,PagerClickHdl) );
//STRIP001 	aPB_NEXT.SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,PagerClickHdl) );
//STRIP001 	aCB_NOTEXT.SetClickHdl( LINK(this,SchDiagramAutoPilotDlg,NoTextClickHdl) );
//STRIP001 
//STRIP001     pET_3_TEXTRUBRIK->SetText( pDoc->XAxisTitle() );
//STRIP001     pET_3_TEXTSIZE->SetText( pDoc->YAxisTitle() );
//STRIP001 
//STRIP001     FreeResource();
//STRIP001 	SetTextSettings(FALSE);
//STRIP001 	pCT_PREVIEW->Show();
//STRIP001 	aCB_NOTEXT.Check (FALSE);
//STRIP001 }
//STRIP001 
//STRIP001 // ----------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::CopyLegendText(SchMemChart *pTarget,SchMemChart *pSource,BOOL bCopyCols)
//STRIP001 {
//STRIP001 	// Fuer die Legende wird der Text der nicht reduzierten Daten benoetigt
//STRIP001 	short nCnt,nMax;
//STRIP001 	if(bCopyCols)
//STRIP001 	{
//STRIP001 	   nMax= pTarget->GetColCount();
//STRIP001 	   for(nCnt=0;nCnt<nMax;nCnt++)
//STRIP001 	   {
//STRIP001 		   pTarget->SetColText(nCnt,pSource->GetColText(nCnt));
//STRIP001 	   }
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 	   nMax= pTarget->GetRowCount();
//STRIP001 	   for(nCnt=0;nCnt<nMax;nCnt++)
//STRIP001 	   {
//STRIP001 		   pTarget->SetRowText(nCnt,pSource->GetRowText(nCnt));
//STRIP001 	   }
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::CopyDataText(SchMemChart *pTarget,SchMemChart *pSource)
//STRIP001 {
//STRIP001 	if(pTarget && pSource)
//STRIP001 	{
//STRIP001 		pTarget->SetMainTitle (pSource->GetMainTitle());
//STRIP001 		pTarget->SetXAxisTitle(pSource->GetXAxisTitle());
//STRIP001 		pTarget->SetYAxisTitle(pSource->GetYAxisTitle());
//STRIP001 		pTarget->SetZAxisTitle(pSource->GetZAxisTitle());
//STRIP001 		pTarget->SetSubTitle  (pSource->GetSubTitle());
//STRIP001 	}
//STRIP001 }
//STRIP001 void SchDiagramAutoPilotDlg::SetDataToOrigin()
//STRIP001 {
//STRIP001 	if(pOriginalData)
//STRIP001 	{
//STRIP001 		// Kopiere die Texte der reduzierten Daten in das Original
//STRIP001 		CopyDataText(pOriginalData,pDoc->GetChartData());
//STRIP001 
//STRIP001 		// Originaldaten wieder in das Document setzen
//STRIP001 		pDoc->ChangeChartData(*pOriginalData,FALSE);
//STRIP001 		// Original freigeben (SetData setzt RefCount hoch)
//STRIP001 		pOriginalData->DecreaseRefCount();
//STRIP001 		pOriginalData=NULL;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 SchDiagramAutoPilotDlg::~SchDiagramAutoPilotDlg()
//STRIP001 {
//STRIP001 	// restoring data is not necessary as the document is a copy of the original
//STRIP001 	// SetDataToOrigin();
//STRIP001 
//STRIP001 	// this is necessary, becaue these attributes are copied to the original
//STRIP001 	RestoreTextSettings();
//STRIP001 
//STRIP001 	DBG_DTOR( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	for( int i=0 ; i<SCH_MAX_PAGES ; i++ )
//STRIP001 	{
//STRIP001 		SchControlList*	pControlList=arrPage[i];
//STRIP001 
//STRIP001 		for( ULONG j=0 ; j<pControlList->Count(); j++ )
//STRIP001 		{
//STRIP001 			delete pControlList->GetObject( j );
//STRIP001 		}
//STRIP001 		delete arrPage[i];
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pCT_PREVIEW;
//STRIP001 }
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 // Reduzierung der Datenpunkte, wenn Darstellung der Preview zu viel Zeit kosten
//STRIP001 // kosten wuerde, ohne dass sich die Darstellungsqualitaet ernsthaft verbessert.
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 BOOL SchDiagramAutoPilotDlg::GetReduceStyle(SvxChartStyle eStyle)
//STRIP001 {
//STRIP001 	BOOL bRetVal;
//STRIP001 
//STRIP001 	switch(eStyle)
//STRIP001 	{
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PIE :
//STRIP001 		case CHSTYLE_3D_PIE :
//STRIP001 		case CHSTYLE_2D_DONUT1 :
//STRIP001 		case CHSTYLE_2D_DONUT2 :
//STRIP001 		case CHSTYLE_2D_PIE_SEGOF1 :
//STRIP001 		case CHSTYLE_2D_PIE_SEGOFALL :
//STRIP001 
//STRIP001 			bRetVal=!(pDoc->IsSwitchData());
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_AREA :
//STRIP001 		case CHSTYLE_3D_STACKEDAREA :
//STRIP001 		case CHSTYLE_3D_PERCENTAREA :
//STRIP001 		case CHSTYLE_3D_SURFACE :
//STRIP001 		case CHSTYLE_3D_XYZ :
//STRIP001 		case CHSTYLE_3D_XYZSYMBOLS :
//STRIP001 		case CHSTYLE_3D_BAR :
//STRIP001 		case CHSTYLE_3D_FLATBAR :
//STRIP001 		case CHSTYLE_3D_STACKEDFLATBAR :
//STRIP001 		case CHSTYLE_3D_PERCENTFLATBAR :
//STRIP001 		case CHSTYLE_2D_NET :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS :
//STRIP001 		case CHSTYLE_2D_NET_STACK :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_STACK :
//STRIP001 		case CHSTYLE_2D_NET_PERCENT :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_PERCENT :
//STRIP001 
//STRIP001 			// Ab hier getestet:
//STRIP001 
//STRIP001 		case CHSTYLE_3D_STRIPE :
//STRIP001 		case CHSTYLE_3D_STACKEDFLATCOLUMN :
//STRIP001 		case CHSTYLE_3D_PERCENTFLATCOLUMN :
//STRIP001 		case CHSTYLE_3D_COLUMN :
//STRIP001 		case CHSTYLE_3D_FLATCOLUMN :
//STRIP001 		default:
//STRIP001 
//STRIP001 			bRetVal=pDoc->IsSwitchData();
//STRIP001 			break;
//STRIP001 
//STRIP001 	}
//STRIP001 	return bRetVal;
//STRIP001 }
//STRIP001 
//STRIP001 //Das sind die max. Datenpunkte pro Reihe, dieim Autopiloten dargestellt werden
//STRIP001 //gibt es mehr so wird gemittelt.
//STRIP001 #define NMAX_DATAPOINTS 10
//STRIP001 
//STRIP001 // Und soviele Datenreihen (Reihe!=Zeile!!!) darf es maximal dort geben
//STRIP001 // Reihe sind die Daten, fr die in der Legende ein Symbol erscheint
//STRIP001 //gibt es mehr, so wird abgeschnitten
//STRIP001 #define NMAX_DATAROWS   20
//STRIP001 
//STRIP001 #define MIN(a,b) ( ((a)<(b))? (a) : (b) )
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::ReduceDataAgain(BOOL bDontBuild)
//STRIP001 {
//STRIP001 	// Diese Routine wird bei ChangeColRow oder Aenderung des Charttypen benutzt
//STRIP001 	// da dann statt der Zeilen die Spalten u.Umg. reduziert werden muessen
//STRIP001 
//STRIP001 	DBG_ASSERT( ! bReducedData || pOriginalData, "original data lost?" );
//STRIP001 
//STRIP001 	if(pOriginalData)
//STRIP001 	{
//STRIP001 		//Es wurde schon reduziert, also Original-Daten nehmen
//STRIP001 		ChangeChartData( *pOriginalData );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		//sonst aus dem Doc holen
//STRIP001 		pDoc->ChangeChartData(
//STRIP001             *ReduceData( *pDoc->GetChartData() ), FALSE, bDontBuild );
//STRIP001 
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 SchMemChart* SchDiagramAutoPilotDlg::ReduceData(SchMemChart& rData)
//STRIP001 {
//STRIP001 	/*
//STRIP001 	Aufrufe:
//STRIP001 
//STRIP001 	ChangeColRow:   (indirekt)
//STRIP001 
//STRIP001 		if(pOriginalData)
//STRIP001 		{
//STRIP001 			//Es wurde schon reduziert, also Original-Daten nehmen
//STRIP001 			ChangeChartData(*pOriginalData);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			//sonst aus dem Doc holen
//STRIP001 			SchMemChart &rReducedData=ReduceData(*pDoc->GetChartData());
//STRIP001 			pDoc->ChangeChartData(rReducedData);
//STRIP001 		}
//STRIP001 
//STRIP001 
//STRIP001 	ChangeChartData( SchMemChart& rData ):
//STRIP001 
//STRIP001 	   SchMemChart& rReducedData=ReduceData(rData );
//STRIP001 	   pDoc->SetChartData( rReducedData );
//STRIP001 
//STRIP001 	Konstruktor 1:
//STRIP001 
//STRIP001 	   SchMemChart& rReducedData=ReduceData(rData);
//STRIP001 	   pDoc->SetChartData (rReducedData);
//STRIP001 
//STRIP001 	Konstruktor 2:
//STRIP001 
//STRIP001 	   SchMemChart &rReducedData=ReduceData(*pDoc->GetChartData());
//STRIP001 	   pDoc->SetChartData(rReducedData,FALSE);
//STRIP001 
//STRIP001 	Beim Verlassen des AutoPiloten muss folgendes getan werden:
//STRIP001 
//STRIP001 	   SetDataToOrigin();
//STRIP001 	   if(pReducedData)delete pReducedData; // Kopie des SchMemchart loeschen
//STRIP001 
//STRIP001 
//STRIP001 	*/
//STRIP001 
//STRIP001 	short nDataCount,nDatarowsCount,nCols,nRows;
//STRIP001 	BOOL  bCollectRows;
//STRIP001 
//STRIP001 	bReducedData=FALSE;
//STRIP001 
//STRIP001 	// Originalkopie freigeben
//STRIP001 	if(pOriginalData)
//STRIP001 		pOriginalData->DecreaseRefCount();
//STRIP001 	pOriginalData=NULL;
//STRIP001 
//STRIP001 	// Reduzierung der Spalten oder der Reihen ?:
//STRIP001 	bCollectRows=GetReduceStyle(pDoc->ChartStyle());
//STRIP001 
//STRIP001 	if(bCollectRows)
//STRIP001 	{
//STRIP001 		nDataCount     = rData.GetRowCount();
//STRIP001 		nDatarowsCount = rData.GetColCount();
//STRIP001 		nCols=MIN(NMAX_DATAROWS,nDatarowsCount);
//STRIP001 		nRows=MIN(NMAX_DATAPOINTS,nDataCount);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nDataCount     = rData.GetColCount();
//STRIP001 		nDatarowsCount = rData.GetRowCount();
//STRIP001 		nRows=MIN(NMAX_DATAROWS,nDatarowsCount);
//STRIP001 		nCols=MIN(NMAX_DATAPOINTS,nDataCount);
//STRIP001 	}
//STRIP001 
//STRIP001 	if((nDataCount > NMAX_DATAPOINTS) || (nDatarowsCount > NMAX_DATAROWS))
//STRIP001 	{
//STRIP001 		pReducedData=new SchMemChart(nCols,nRows);
//STRIP001 		// wird vom Model geloescht, daher kein delete des alten
//STRIP001 		// pReducedData und kein festhalten noetig:
//STRIP001 
//STRIP001         // copy col/row descriptions and titles
//STRIP001         pReducedData->SetNonNumericData( rData );
//STRIP001 
//STRIP001 		if(pReducedData)
//STRIP001 		{
//STRIP001 			short nRowCnt,nColCnt,nCollect,nCollectCnt,nTmp;
//STRIP001 			double dCollected;
//STRIP001 
//STRIP001 			pOriginalData=&rData;
//STRIP001 			pOriginalData->IncreaseRefCount();   //festhalten
//STRIP001 
//STRIP001 			//In reduziertes Object die Original-Texte kopieren:
//STRIP001 			CopyDataText(pReducedData,pOriginalData);
//STRIP001 			CopyLegendText(pReducedData,pOriginalData,bCollectRows);
//STRIP001 
//STRIP001 			//nCollect Elemente zusammenfassen, z.B. MinMax oder Mittelwert etc.
//STRIP001 			nCollect=nDataCount/NMAX_DATAPOINTS;
//STRIP001 
//STRIP001 			if(bCollectRows)
//STRIP001 			{
//STRIP001 				for(nColCnt=0;nColCnt<nCols;nColCnt++)
//STRIP001 				{
//STRIP001 					for(nRowCnt=0;nRowCnt<nRows;nRowCnt++)
//STRIP001 					{
//STRIP001 						if(nDataCount > NMAX_DATAPOINTS)
//STRIP001 						{
//STRIP001 							dCollected=0.0;
//STRIP001 							for(nCollectCnt=0;nCollectCnt<nCollect;nCollectCnt++)
//STRIP001 							{
//STRIP001 								nTmp=nRowCnt*nCollect+nCollectCnt;
//STRIP001 								dCollected+=(pOriginalData->GetData(nColCnt,nTmp));
//STRIP001 							}
//STRIP001 							//Wir benutzen Mittelwert der Daten
//STRIP001 							dCollected=dCollected/(double)nCollectCnt;
//STRIP001 							pReducedData->SetData(nColCnt,nRowCnt,dCollected);
//STRIP001 						}
//STRIP001 						else  //Nur abschneiden
//STRIP001 						{
//STRIP001 							 pReducedData->SetData(nColCnt,nRowCnt,pOriginalData->GetData(nColCnt,nRowCnt));
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				for(nRowCnt=0;nRowCnt<nRows;nRowCnt++)
//STRIP001 				{
//STRIP001 					for(nColCnt=0;nColCnt<nCols;nColCnt++)
//STRIP001 					{
//STRIP001 						if(nDataCount > NMAX_DATAPOINTS)
//STRIP001 						{
//STRIP001 
//STRIP001 							dCollected=0.0;
//STRIP001 							for(nCollectCnt=0;nCollectCnt<nCollect;nCollectCnt++)
//STRIP001 							{
//STRIP001 								nTmp=nColCnt*nCollect+nCollectCnt;
//STRIP001 								dCollected+=(pOriginalData->GetData(nTmp,nRowCnt));
//STRIP001 							}
//STRIP001 							//Wir benutzen Mittelwert der Daten
//STRIP001 							dCollected=dCollected/(double)nCollectCnt;
//STRIP001 							pReducedData->SetData(nColCnt,nRowCnt,dCollected);
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							pReducedData->SetData(nColCnt,nRowCnt,pOriginalData->GetData(nColCnt,nRowCnt));
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			bReducedData=TRUE;
//STRIP001 			return pReducedData;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return &rData;
//STRIP001 }
//STRIP001 //Texte abschalten, darf erst nach InitFromModel passieren:
//STRIP001 void SchDiagramAutoPilotDlg::SetTextSettings(BOOL bON)
//STRIP001 {
//STRIP001 	pDoc->ShowMainTitle()=bON;
//STRIP001 	pDoc->ShowSubTitle()=bON;
//STRIP001 	pDoc->ShowXAxisTitle()=bON;
//STRIP001 	pDoc->ShowYAxisTitle()=bON;
//STRIP001 	pDoc->ShowZAxisTitle()=bON;
//STRIP001 	pDoc->ShowXDescr(bON);
//STRIP001 	pDoc->ShowYDescr(bON);
//STRIP001 	pDoc->ShowZDescr(bON);
//STRIP001 	pDoc->SetShowLegend (bON);
//STRIP001 
//STRIP001 /*    Das hier war doch eh Unsinn, oder ?
//STRIP001 pDoc->ValFo rmat()         = bON ? nValFo rmat:CHDESCR_NONE;
//STRIP001 	pDoc->Percent ValFo rmat()  = bON ? nPerce ntValFo rmat:CHDESCR_NONE;
//STRIP001 	pDoc->Percent Descr Format()= bON ? nPerce ntDescr Format:CHDESCR_NONE;
//STRIP001 	pDoc->DescrFo rmat()       = bON ? nDescr Format:CHDESCR_NONE;
//STRIP001 	*/
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::RestoreTextSettings()
//STRIP001  {
//STRIP001 	pDoc->ShowSubTitle()=bShowSubTitle;
//STRIP001 	pDoc->ShowMainTitle()=bShowMainTitle;
//STRIP001 	pDoc->ShowXAxisTitle()=bShowXAxisTitle;
//STRIP001 	pDoc->ShowYAxisTitle()=bShowYAxisTitle;
//STRIP001 	pDoc->ShowZAxisTitle()=bShowZAxisTitle;
//STRIP001 	pDoc->ShowXDescr(bShowXDescr);
//STRIP001 	pDoc->ShowYDescr(bShowYDescr);
//STRIP001 	pDoc->ShowZDescr(bShowZDescr);
//STRIP001 	pDoc->SetShowLegend (bShowLegend);
//STRIP001  }
//STRIP001 void SchDiagramAutoPilotDlg::BuildChart()
//STRIP001 {
//STRIP001 	if(!bNoText)
//STRIP001 	{
//STRIP001 		RestoreTextSettings();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SetTextSettings(FALSE);
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	pDoc->BuildChart(FALSE);
//STRIP001 }
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::ChangeChartData( SchMemChart& rData )
//STRIP001 {
//STRIP001 	pDoc->SetChartData( * ReduceData( rData ), FALSE );
//STRIP001 	BuildChart(); //lokales BuildChart
//STRIP001 	pCT_PREVIEW->Invalidate();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::SetCurrentPage( USHORT nNewPageNr )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 	DBG_ASSERT( nNewPageNr<SCH_MAX_PAGES , "range error" );
//STRIP001 
//STRIP001 	for( USHORT nPagNr=0 ; nPagNr<SCH_MAX_PAGES ; nPagNr++ )
//STRIP001 	{
//STRIP001 		SchControlList*	pControlList=arrPage[nPagNr];
//STRIP001 
//STRIP001 		for( ULONG i=0 ; i<pControlList->Count() ; i++ )
//STRIP001 		{
//STRIP001 			Control*	pControl = pControlList->GetObject( i );
//STRIP001 
//STRIP001 			if( nNewPageNr == nPagNr )
//STRIP001 				pControl->Show();
//STRIP001 			else
//STRIP001 				pControl->Hide();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	nCurPageNr = nNewPageNr;
//STRIP001 
//STRIP001 	if( nCurPageNr > CHARTTYPE_PAGE )
//STRIP001 		aPB_PREV.Enable(TRUE);
//STRIP001 	else if( ! bHasPrePage )
//STRIP001 		aPB_PREV.Enable (FALSE);
//STRIP001 
//STRIP001 	if(pDoc->GetMemChart()->GetTranslation()!=TRANS_NONE)
//STRIP001 	{
//STRIP001 		aRB_DATAROWS.Enable(FALSE);
//STRIP001 		aRB_DATACOLS.Enable(FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bNextEnabled = (nCurPageNr < CHARTDETAILS_PAGE);
//STRIP001 
//STRIP001 	// toggle correct Defaultbutton
//STRIP001 	if( bNextEnabled )
//STRIP001 	{
//STRIP001 		aPB_EXECUTE.SetStyle( aPB_EXECUTE.GetStyle() & (~ WB_DEFBUTTON) );
//STRIP001 		aPB_NEXT.SetStyle( aPB_NEXT.GetStyle() | WB_DEFBUTTON );
//STRIP001 		aPB_NEXT.GrabFocus();
//STRIP001 	}
//STRIP001 	else if( aPB_EXECUTE.IsEnabled() )
//STRIP001 	{
//STRIP001 		aPB_NEXT.SetStyle( aPB_NEXT.GetStyle() & (~ WB_DEFBUTTON) );
//STRIP001 		aPB_EXECUTE.SetStyle( aPB_EXECUTE.GetStyle() | WB_DEFBUTTON );
//STRIP001 		aPB_EXECUTE.GrabFocus();
//STRIP001 	}
//STRIP001 	aPB_NEXT.Enable( bNextEnabled );
//STRIP001 
//STRIP001 	switch( nCurPageNr )
//STRIP001 	{
//STRIP001 		case CHARTTYPE_PAGE:
//STRIP001 		pCT_1_CHARTTYPE->GrabFocus();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case CHARTVARIANT_PAGE:
//STRIP001 		pCT_2_CHARTVARIANT->GrabFocus();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case CHARTDETAILS_PAGE:
//STRIP001 			if( pET_3_TEXTTITLE->IsEnabled() )
//STRIP001 				pET_3_TEXTTITLE->GrabFocus();
//STRIP001 			else
//STRIP001 				pCB_3_TEXTTITLE->GrabFocus();
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, PagerClickHdl, Button *, pButton )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	if( pButton == &aPB_PREV )
//STRIP001 	{
//STRIP001 		if( nCurPageNr>CHARTTYPE_PAGE )
//STRIP001 		{
//STRIP001 			SetCurrentPage( nCurPageNr - 1 );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			FillOutputItemSet();
//STRIP001 			EndDialog( 100 );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( pButton == &aPB_NEXT && nCurPageNr<CHARTDETAILS_PAGE )
//STRIP001 	{
//STRIP001 		SetCurrentPage( nCurPageNr + 1 );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, ExecuteClickHdl, Button *, pButton )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	if( pButton == &aPB_EXECUTE )
//STRIP001 	{
//STRIP001         // #i4158# grab the focus.  If the focus has been on a text field
//STRIP001         // before, the EditLoseFocusHdl Link is called, which applies the
//STRIP001         // entered text.
//STRIP001         aPB_EXECUTE.GrabFocus();
//STRIP001 		FillOutputItemSet();
//STRIP001 		EndDialog( RET_OK );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, SelectChartTypeHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001     ChType eOldType = GetTypeFromStyle( pDoc->ChartStyle() );
//STRIP001 	ChType eNewType = static_cast< ChType >( pCT_1_CHARTTYPE->GetSelectItemId() );
//STRIP001     NewAxisText( eOldType, eNewType );
//STRIP001 
//STRIP001 	SelectVariantSet( eNewType, CHVARIANT_INVALID );
//STRIP001 	ExecuteVariant();
//STRIP001 	pCT_PREVIEW->Invalidate();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, SelectChartVariantHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	ExecuteVariant();
//STRIP001 	EnableOverlap ();
//STRIP001 	pCT_PREVIEW->Invalidate();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::SelectVariantSet( USHORT nNewId, ChVariant eVariant )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	pCT_2_CHARTVARIANT->Clear();
//STRIP001 
//STRIP001 	long nOffset=0;
//STRIP001 
//STRIP001 	switch(pDoc->GetChartShapeType())
//STRIP001 	{
//STRIP001 		case CHART_SHAPE3D_CONE:
//STRIP001 			nOffset=OFFSET_CONE;
//STRIP001 			break;
//STRIP001 		case CHART_SHAPE3D_PYRAMID:
//STRIP001 			nOffset=OFFSET_PYRAMID;
//STRIP001 			break;
//STRIP001 		case CHART_SHAPE3D_CYLINDER:
//STRIP001 			nOffset=OFFSET_ROUND;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001     bool bIsHighContrast = ( true && GetDisplayBackground().GetColor().IsDark() );
//STRIP001 
//STRIP001 	switch( nNewId )
//STRIP001 	{
//STRIP001 		case CHTYPE_2D_LINE:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINE,
//STRIP001 										   SELECT_BITMAP( BMP_LINES_2D_1 ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINE_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_LINES_2D_2 ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINE_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_LINES_2D_3 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINESYMB,
//STRIP001 										   SELECT_BITMAP( BMP_LINESYMB_2D_1 ),
//STRIP001 										   String(SchResId(STR_SYMBOL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINESYMB_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_LINESYMB_2D_2 ),
//STRIP001 										   String(SchResId(STR_SYMBOL_STACK)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINESYMB_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_LINESYMB_2D_3 ),
//STRIP001 										   String(SchResId(STR_SYMBOL_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_CUBIC_SPLINE,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_CUBIC ),
//STRIP001 										   String(SchResId(STR_SPLINE_CUBIC)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_CUBIC_SPLINE_SYMBOL,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_CUBIC_SYMBOL ),
//STRIP001 										   String(SchResId(STR_SPLINE_CUBIC_SYMBOL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_B_SPLINE,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_B ),
//STRIP001 										   String(SchResId(STR_SPLINE_B)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_B_SPLINE_SYMBOL,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_B_SYMBOL ),
//STRIP001 										   String(SchResId(STR_SPLINE_B_SYMBOL)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_LINE);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_2D_AREA:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_AREA,
//STRIP001 										   SELECT_BITMAP( BMP_AREAS_2D_1 ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_AREA_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_AREAS_2D ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_AREA_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_AREAS_2D_3 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_AREA_STACKED);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_2D_COLUMN:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_COLUMN,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_2D_1 ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_COLUMN_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_2D_2 ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_COLUMN_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_2D_3 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINE_COLUMN,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_2D_4 ),
//STRIP001 										   String(SchResId(STR_LINE_COLUMN)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_LINE_STACKEDCOLUMN,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_2D_5 ),
//STRIP001 										   String(SchResId(STR_LINE_STACKEDCOLUMN)));
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_COLUMN);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_2D_BAR:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_BAR,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_2D_1 ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_BAR_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_2D_2 ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_BAR_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_2D_3 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_BAR);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_2D_PIE:
//STRIP001 			{
//STRIP001 				pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_PIE,
//STRIP001 											   SELECT_BITMAP( BMP_CIRCLES_2D ),
//STRIP001 											   String(SchResId(STR_NORMAL)));
//STRIP001 				pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_DONUT1,
//STRIP001 											   SELECT_BITMAP( BMP_DONUT1_2D ),
//STRIP001 											   String(SchResId(STR_DONUT1)));
//STRIP001 				String aResStr( SchResId( STR_OFS ));
//STRIP001 				String aOfsStr = aResStr;
//STRIP001 
//STRIP001 				xub_StrLen nFound = aResStr.SearchAscii( "$(N)" );
//STRIP001 				if( nFound != STRING_NOTFOUND )
//STRIP001 					aOfsStr.Replace( nFound, RTL_CONSTASCII_LENGTH( "$(N)" ), String::CreateFromInt32( 1 ));
//STRIP001 
//STRIP001 				pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_PIE_SEGOFS_1,
//STRIP001 											   SELECT_BITMAP( BMP_CIRCLES_2D_1 ),
//STRIP001 											   aOfsStr);
//STRIP001 
//STRIP001 				aOfsStr = aResStr;
//STRIP001 				if( nFound != STRING_NOTFOUND )
//STRIP001 					aOfsStr.Replace( nFound, RTL_CONSTASCII_LENGTH( "$(N)" ), String::CreateFromInt32( 2 ));
//STRIP001 
//STRIP001 				pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_PIE_SEGOFS_ALL,
//STRIP001 											   SELECT_BITMAP( BMP_CIRCLES_2D_2 ),
//STRIP001 											   aOfsStr);
//STRIP001 				pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 											   ? eVariant
//STRIP001 											   : CHVARIANT_2D_PIE);
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 		case CHTYPE_2D_XY:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_XY_SYMB,
//STRIP001 										   SELECT_BITMAP( BMP_XYSYMB_2D ),
//STRIP001 										   String(SchResId(STR_ONLY_SYMBOLS)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_XY,
//STRIP001 										   SELECT_BITMAP( BMP_XY_2D ),
//STRIP001 										   String(SchResId(STR_LINE_SYMBOLS)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_XY_LINE,
//STRIP001 										   SELECT_BITMAP( BMP_LINES_2D_1 ),
//STRIP001 										   String(SchResId(STR_ONLY_LINES)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_CUBIC_SPLINE_XY,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_CUBIC ),
//STRIP001 										   String(SchResId(STR_SPLINE_CUBIC)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_CUBIC_SPLINE_SYMBOL_XY,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_CUBIC_SYMBOL ),
//STRIP001 										   String(SchResId(STR_SPLINE_CUBIC_SYMBOL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_B_SPLINE_XY,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_B ),
//STRIP001 										   String(SchResId(STR_SPLINE_B)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_B_SPLINE_SYMBOL_XY,
//STRIP001 										   SELECT_BITMAP( BMP_SPLINE_B_SYMBOL ),
//STRIP001 										   String(SchResId(STR_SPLINE_B_SYMBOL)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_XY_SYMB);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_2D_NET:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_NET,
//STRIP001 										   SELECT_BITMAP( BMP_NET_2D ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_NET_STACK,
//STRIP001 										   SELECT_BITMAP( BMP_NET_2D_STACK ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_NET_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_NET_2D_PERCENT ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_NETSYMB,
//STRIP001 										   SELECT_BITMAP( BMP_NETSYMB_2D ),
//STRIP001 										   String(SchResId(STR_SYMBOL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_NETSYMB_STACK,
//STRIP001 										   SELECT_BITMAP( BMP_NETSYMB_2D_STACK ),
//STRIP001 										   String(SchResId(STR_SYMBOL_STACK)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_NETSYMB_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_NETSYMB_2D_PERCENT ),
//STRIP001 										   String(SchResId(STR_SYMBOL_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_NET);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_3D_STRIPE:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_STRIPE,
//STRIP001 										   SELECT_BITMAP( BMP_LINES_3D ),
//STRIP001 										   String(SchResId(STR_DEEP)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem(CHVARIANT_3D_STRIPE);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_3D_AREA:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_AREA_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_AREAS_3D_1 ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_AREA_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_AREAS_3D_2 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_AREA,
//STRIP001 										   SELECT_BITMAP( BMP_AREAS_3D ),
//STRIP001 										   String(SchResId(STR_DEEP)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_3D_AREA_STACKED);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_3D_COLUMN:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_3D_1 ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_3D_2 ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_3D_3 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN,
//STRIP001 										   SELECT_BITMAP( BMP_COLUMNS_3D ),
//STRIP001 										   String(SchResId(STR_DEEP)));
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_SAEULE_3D_1 ),
//STRIP001 										   String(SchResId(STR_SAEULE_3D_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_STACKED + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_SAEULE_3D_2 ),
//STRIP001 										   String(SchResId(STR_SAEULE_3D_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_PERCENT + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_SAEULE_3D_3 ),
//STRIP001 										   String(SchResId(STR_SAEULE_3D_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_SAEULE_3D_4 ),
//STRIP001 										   String(SchResId(STR_SAEULE_3D_4)));
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMID_3D_1 ),
//STRIP001 										   String(SchResId(STR_PYRAMID_3D_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_STACKED + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMID_3D_2 ),
//STRIP001 										   String(SchResId(STR_PYRAMID_3D_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_PERCENT + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMID_3D_3 ),
//STRIP001 										   String(SchResId(STR_PYRAMID_3D_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMID_3D_4 ),
//STRIP001 										   String(SchResId(STR_PYRAMID_3D_4)));
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGEL_3D_1 ),
//STRIP001 										   String(SchResId(STR_KEGEL_3D_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_STACKED + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGEL_3D_2 ),
//STRIP001 										   String(SchResId(STR_KEGEL_3D_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN_FLAT_PERCENT + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGEL_3D_3 ),
//STRIP001 										   String(SchResId(STR_KEGEL_3D_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_COLUMN + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGEL_3D_4 ),
//STRIP001 										   String(SchResId(STR_KEGEL_3D_4)));
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant + nOffset
//STRIP001 										   : CHVARIANT_3D_COLUMN_FLAT);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_3D_PIE:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_PIE,
//STRIP001 										   SELECT_BITMAP( BMP_CIRCLES_3D ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem(CHVARIANT_3D_PIE);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHTYPE_3D_BAR:
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_3D_1 ),
//STRIP001 										   String(SchResId(STR_NORMAL)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_STACKED,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_3D_2 ),
//STRIP001 										   String(SchResId(STR_STACKED)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_PERCENT,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_3D_3 ),
//STRIP001 										   String(SchResId(STR_PERCENT)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR,
//STRIP001 										   SELECT_BITMAP( BMP_BARS_3D ),
//STRIP001 										   String(SchResId(STR_DEEP)));
//STRIP001 
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_ROEHRE_3D_1 ),
//STRIP001 										   String(SchResId(STR_ROEHRE_3D_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_STACKED + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_ROEHRE_3D_2 ),
//STRIP001 										   String(SchResId(STR_ROEHRE_3D_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_PERCENT + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_ROEHRE_3D_3 ),
//STRIP001 										   String(SchResId(STR_ROEHRE_3D_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR + OFFSET_ROUND,
//STRIP001 										   SELECT_BITMAP( BMP_ROEHRE_3D_4 ),
//STRIP001 										   String(SchResId(STR_ROEHRE_3D_4)));
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMIDQ_3D_1 ),
//STRIP001 										   String(SchResId(STR_PYRAMIDQ_3D_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_STACKED + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMIDQ_3D_2 ),
//STRIP001 										   String(SchResId(STR_PYRAMIDQ_3D_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_PERCENT + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMIDQ_3D_3 ),
//STRIP001 										   String(SchResId(STR_PYRAMIDQ_3D_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR + OFFSET_PYRAMID,
//STRIP001 										   SELECT_BITMAP( BMP_PYRAMIDQ_3D_4 ),
//STRIP001 										   String(SchResId(STR_PYRAMIDQ_3D_4)));
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGELQ_3D_1 ),
//STRIP001 										   String(SchResId(STR_KEGELQ_3D_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_STACKED + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGELQ_3D_2 ),
//STRIP001 										   String(SchResId(STR_KEGELQ_3D_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR_FLAT_PERCENT + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGELQ_3D_3 ),
//STRIP001 										   String(SchResId(STR_KEGELQ_3D_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_3D_BAR + OFFSET_CONE,
//STRIP001 										   SELECT_BITMAP( BMP_KEGELQ_3D_4 ),
//STRIP001 										   String(SchResId(STR_KEGELQ_3D_4)));
//STRIP001 
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant + nOffset
//STRIP001 										   : CHVARIANT_3D_BAR_FLAT);
//STRIP001 			break;
//STRIP001 
//STRIP001 
//STRIP001 		case CHTYPE_2D_STOCK:
//STRIP001 
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_STOCK_1,
//STRIP001 										   SELECT_BITMAP( BMP_STOCK_1 ),
//STRIP001 										   String(SchResId(STR_STOCK_1)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_STOCK_2,
//STRIP001 										   SELECT_BITMAP( BMP_STOCK_2 ),
//STRIP001 										   String(SchResId(STR_STOCK_2)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_STOCK_3,
//STRIP001 										   SELECT_BITMAP( BMP_STOCK_3 ),
//STRIP001 										   String(SchResId(STR_STOCK_3)));
//STRIP001 			pCT_2_CHARTVARIANT->InsertItem(CHVARIANT_2D_STOCK_4,
//STRIP001 										   SELECT_BITMAP( BMP_STOCK_4 ),
//STRIP001 										   String(SchResId(STR_STOCK_4)));
//STRIP001 			pCT_2_CHARTVARIANT->SelectItem((eVariant != CHVARIANT_INVALID)
//STRIP001 										   ? eVariant
//STRIP001 										   : CHVARIANT_2D_STOCK_2);
//STRIP001 			break;
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	// make selected Item visible
//STRIP001 	pCT_2_CHARTVARIANT->SetFirstLine( pCT_2_CHARTVARIANT->GetItemPos( pCT_2_CHARTVARIANT->GetSelectItemId() )
//STRIP001 									  / pCT_2_CHARTVARIANT->GetColCount() );
//STRIP001 
//STRIP001 	EnableOverlap ();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, EditLoseFocusHdl, Control *, pControl )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	Edit*	pEdit = (Edit*)pControl;
//STRIP001 
//STRIP001 	if(pEdit->IsModified())
//STRIP001 	{
//STRIP001 		String *pDocText=NULL, aOldText, aNewText;
//STRIP001 		aNewText = pEdit->GetText();
//STRIP001 
//STRIP001 		if(pEdit==pET_3_TEXTTITLE) pDocText = &pDoc->MainTitle();
//STRIP001 		if(pEdit==pET_3_TEXTRUBRIK)pDocText = &pDoc->XAxisTitle();
//STRIP001 		if(pEdit==pET_3_TEXTSIZE)  pDocText = &pDoc->YAxisTitle();
//STRIP001 		if(pEdit==pET_3_TEXTSECOND)pDocText = &pDoc->ZAxisTitle();
//STRIP001 
//STRIP001 		if(pDocText)
//STRIP001 		{
//STRIP001 			aOldText=*pDocText;
//STRIP001 
//STRIP001 			if( aNewText != aOldText )
//STRIP001 			{
//STRIP001 				*pDocText = aNewText;
//STRIP001 				if(!bNoText)BuildChart(); //lokales BuildChart
//STRIP001 			}
//STRIP001 			pCT_PREVIEW->Invalidate();
//STRIP001 			pEdit->ClearModifyFlag();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, RadioButtonClickHdl, Button *, pButton )
//STRIP001 {
//STRIP001 	bool bOldSwitch = ( pDoc->IsSwitchData() == TRUE );
//STRIP001     bool bNewSwitch = ( pButton == &aRB_DATACOLS );
//STRIP001     bool bChanges = ( bOldSwitch != bNewSwitch );
//STRIP001 
//STRIP001 	ChType eType = static_cast< ChType >( pCT_1_CHARTTYPE->GetSelectItemId() );
//STRIP001 
//STRIP001     // must be called before BuildChart()
//STRIP001     NewAxisText( eType, eType, bChanges );
//STRIP001 
//STRIP001     // may perform a BuildChart()
//STRIP001     pDoc->ChangeSwitchData( bNewSwitch );
//STRIP001 
//STRIP001 	if( bChanges )
//STRIP001 		ReduceDataAgain();
//STRIP001 
//STRIP001     BuildChart();   // method of this class
//STRIP001 	pCT_PREVIEW->Invalidate();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::StoreTextSettings()
//STRIP001 {
//STRIP001 
//STRIP001 	if(bStored)
//STRIP001 		return;
//STRIP001 
//STRIP001 	bStored=TRUE;
//STRIP001 	bShowLegend    = pDoc->GetShowLegend();
//STRIP001 	bShowSubTitle  = pDoc->ShowSubTitle();
//STRIP001 	bShowMainTitle = pDoc->ShowMainTitle();
//STRIP001 	bShowXAxisTitle= pDoc->ShowXAxisTitle();
//STRIP001 	bShowYAxisTitle= pDoc->ShowYAxisTitle();
//STRIP001 	bShowZAxisTitle= pDoc->ShowZAxisTitle();
//STRIP001 	bShowXDescr    = pDoc->ShowXDescr();
//STRIP001 	bShowYDescr    = pDoc->ShowYDescr();
//STRIP001 	bShowZDescr    = pDoc->ShowZDescr();
//STRIP001 
//STRIP001 }
//STRIP001 void SchDiagramAutoPilotDlg::InitFromModel()
//STRIP001 {
//STRIP001 	SvxChartStyle eStyle = pDoc->ChartStyle();
//STRIP001 	ChType eType = GetTypeFromStyle( eStyle );
//STRIP001 
//STRIP001 	pCT_1_CHARTTYPE->SelectItem( eType );
//STRIP001 
//STRIP001 	// make selected Item visible
//STRIP001 	USHORT nSelLine = pCT_1_CHARTTYPE->GetItemPos( pCT_1_CHARTTYPE->GetSelectItemId() )
//STRIP001 		/ pCT_1_CHARTTYPE->GetColCount();
//STRIP001 
//STRIP001 	// move upward until item is visible in last line shown
//STRIP001 	if( nSelLine >= pCT_1_CHARTTYPE->GetLineCount() )
//STRIP001 		pCT_1_CHARTTYPE->SetFirstLine( nSelLine - pCT_1_CHARTTYPE->GetLineCount() + 1 );
//STRIP001 
//STRIP001 	BOOL bIs3D = FALSE;
//STRIP001 
//STRIP001 	switch (eType)
//STRIP001 	{
//STRIP001 		case CHSTYLE_3D_STRIPE :
//STRIP001 		case CHSTYLE_3D_COLUMN :
//STRIP001 		case CHSTYLE_3D_FLATCOLUMN :
//STRIP001 		case CHSTYLE_3D_STACKEDFLATCOLUMN :
//STRIP001 		case CHSTYLE_3D_PERCENTFLATCOLUMN :
//STRIP001 		case CHSTYLE_3D_AREA :
//STRIP001 		case CHSTYLE_3D_STACKEDAREA :
//STRIP001 		case CHSTYLE_3D_PERCENTAREA :
//STRIP001 		case CHSTYLE_3D_SURFACE :
//STRIP001 		case CHSTYLE_3D_XYZ :
//STRIP001 		case CHSTYLE_3D_XYZSYMBOLS :
//STRIP001 		case CHSTYLE_3D_BAR :
//STRIP001 		case CHSTYLE_3D_FLATBAR :
//STRIP001 		case CHSTYLE_3D_STACKEDFLATBAR :
//STRIP001 		case CHSTYLE_3D_PERCENTFLATBAR :
//STRIP001 			pCB_2_ZGRID->Enable(TRUE);
//STRIP001 			pET_3_TEXTSECOND->Enable(TRUE);
//STRIP001 			bIs3D = TRUE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PIE :
//STRIP001 		case CHSTYLE_3D_PIE :
//STRIP001 		case CHSTYLE_2D_DONUT1 :
//STRIP001 		case CHSTYLE_2D_DONUT2 :
//STRIP001 		case CHSTYLE_2D_PIE_SEGOF1 :
//STRIP001 		case CHSTYLE_2D_PIE_SEGOFALL :
//STRIP001 			pCB_2_XGRID->Enable (FALSE);
//STRIP001 			pCB_2_YGRID->Enable (FALSE);
//STRIP001 			pCB_2_ZGRID->Enable (FALSE);
//STRIP001 			pET_3_TEXTRUBRIK->Enable (FALSE);
//STRIP001 			pET_3_TEXTSIZE->Enable (FALSE);
//STRIP001 			pET_3_TEXTSECOND->Enable (FALSE);
//STRIP001 
//STRIP001 			if (eStyle == CHSTYLE_3D_PIE) bIs3D = TRUE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS :
//STRIP001 		case CHSTYLE_2D_NET_STACK :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_STACK :
//STRIP001 		case CHSTYLE_2D_NET_PERCENT :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_PERCENT :
//STRIP001 			pET_3_TEXTRUBRIK->Enable (FALSE);
//STRIP001 			break;
//STRIP001 
//STRIP001 		default :
//STRIP001 			;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bIs3D)
//STRIP001 	{
//STRIP001 		pCB_2_ZGRID->Enable (FALSE);
//STRIP001 		pET_3_TEXTSECOND->Enable (FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	SelectVariantSet( eType, TranslateFromModel (eStyle));
//STRIP001 	StoreTextSettings();
//STRIP001 
//STRIP001 	pET_3_TEXTTITLE->SetText( pDoc->MainTitle() );
//STRIP001 	pET_3_TEXTSECOND->SetText( pDoc->ZAxisTitle() );
//STRIP001 
//STRIP001 	pET_3_TEXTTITLE->ClearModifyFlag();
//STRIP001 	pET_3_TEXTRUBRIK->ClearModifyFlag();
//STRIP001 	pET_3_TEXTSIZE->ClearModifyFlag();
//STRIP001 	pET_3_TEXTSECOND->ClearModifyFlag();
//STRIP001 
//STRIP001 	pCB_2_XGRID->Check( pDoc->ShowYGridMain() );
//STRIP001 	pCB_2_YGRID->Check( pDoc->ShowXGridMain() );
//STRIP001 	pCB_2_ZGRID->Check( pDoc->ShowZGridMain() );
//STRIP001 
//STRIP001     pCB_3_LEGEND->Check( bShowLegend );
//STRIP001 	pCB_3_XTEXT->Check( bShowXAxisTitle);
//STRIP001 	pCB_3_YTEXT->Check( bShowYAxisTitle);
//STRIP001 	pCB_3_ZTEXT->Check( bShowZAxisTitle);
//STRIP001 	pCB_3_TEXTTITLE->Check( bShowMainTitle  );
//STRIP001 
//STRIP001 	pET_3_TEXTTITLE->Enable(bShowMainTitle);
//STRIP001 
//STRIP001 	EnableOverlap();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::SetupModel()
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::ScalePreview()
//STRIP001 {
//STRIP001 	SchChartDocShell &rMyDoc = (SchChartDocShell &)*pDocSh;
//STRIP001 
//STRIP001 	static Point aDefPoint;
//STRIP001 	Rectangle rRect( aDefPoint, pCT_PREVIEW->GetSizePixel());
//STRIP001 	rRect = PixelToLogic( rRect, pCT_PREVIEW->GetMapMode() );
//STRIP001 	rMyDoc.SetVisArea( rRect );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::ExecuteVariant()
//STRIP001 {
//STRIP001 	short i;
//STRIP001 	short nPieSegCnt = pDoc->PieSegCount();
//STRIP001 
//STRIP001 	for (i = 0; i < nPieSegCnt; i++)
//STRIP001 		pDoc->SetPieSegOfs( i, 0 );
//STRIP001 
//STRIP001 	long nId = pCT_2_CHARTVARIANT->GetSelectItemId();
//STRIP001 	nShapeType = CHART_SHAPE3D_SQUARE;
//STRIP001 	if(nId > OFFSET_CONE)
//STRIP001 	{
//STRIP001 		nId -= OFFSET_CONE;
//STRIP001 		nShapeType = CHART_SHAPE3D_CONE;
//STRIP001 	}
//STRIP001 	if(nId>OFFSET_ROUND)
//STRIP001 	{
//STRIP001 		nId -= OFFSET_ROUND;
//STRIP001 		nShapeType = CHART_SHAPE3D_CYLINDER;
//STRIP001 	}
//STRIP001 	if(nId>OFFSET_PYRAMID)
//STRIP001 	{
//STRIP001 		nId -= OFFSET_PYRAMID;
//STRIP001 		nShapeType = CHART_SHAPE3D_PYRAMID;
//STRIP001 	}
//STRIP001 
//STRIP001 	ChVariant eVariant = (ChVariant)nId;
//STRIP001 
//STRIP001 	SvxChartStyle eStyle,eOldStyle;
//STRIP001 
//STRIP001 	switch( eVariant )
//STRIP001 	{
//STRIP001 		case CHVARIANT_2D_LINE:
//STRIP001 			eStyle = CHSTYLE_2D_LINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINE_STACKED:
//STRIP001 			eStyle = CHSTYLE_2D_STACKEDLINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINE_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_PERCENTLINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINESYMB:
//STRIP001 			eStyle = CHSTYLE_2D_LINESYMBOLS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINESYMB_STACKED:
//STRIP001 			eStyle = CHSTYLE_2D_STACKEDLINESYM;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINESYMB_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_PERCENTLINESYM;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_COLUMN:
//STRIP001 			eStyle = CHSTYLE_2D_COLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_COLUMN_STACKED:
//STRIP001 			eStyle = CHSTYLE_2D_STACKEDCOLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_COLUMN_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_PERCENTCOLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINE_COLUMN:
//STRIP001 			eStyle = CHSTYLE_2D_LINE_COLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_LINE_STACKEDCOLUMN:
//STRIP001 			eStyle = CHSTYLE_2D_LINE_STACKEDCOLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_BAR:
//STRIP001 			eStyle = CHSTYLE_2D_BAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_BAR_STACKED:
//STRIP001 			eStyle = CHSTYLE_2D_STACKEDBAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_BAR_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_PERCENTBAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_AREA:
//STRIP001 			eStyle = CHSTYLE_2D_AREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_AREA_STACKED:
//STRIP001 			eStyle = CHSTYLE_2D_STACKEDAREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_AREA_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_PERCENTAREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_PIE:
//STRIP001 			eStyle = CHSTYLE_2D_PIE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_PIE_SEGOFS_1:
//STRIP001 			eStyle = CHSTYLE_2D_PIE_SEGOF1;
//STRIP001 			pDoc->SetPieSegOfs( 0, 10 );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_PIE_SEGOFS_ALL:
//STRIP001 			eStyle = CHSTYLE_2D_PIE_SEGOFALL;
//STRIP001 			for (i = 0; i < nPieSegCnt; i++)
//STRIP001 				pDoc->SetPieSegOfs( i, 10 );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_XY_SYMB:
//STRIP001 			eStyle = CHSTYLE_2D_XYSYMBOLS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_XY:
//STRIP001 			eStyle = CHSTYLE_2D_XY;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_XY_LINE:
//STRIP001 			eStyle = CHSTYLE_2D_XY_LINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NET:
//STRIP001 			eStyle = CHSTYLE_2D_NET;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NETSYMB:
//STRIP001 			eStyle = CHSTYLE_2D_NET_SYMBOLS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NET_STACK:
//STRIP001 			eStyle = CHSTYLE_2D_NET_STACK;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NETSYMB_STACK:
//STRIP001 			eStyle = CHSTYLE_2D_NET_SYMBOLS_STACK;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NET_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_NET_PERCENT;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NETSYMB_PERCENT:
//STRIP001 			eStyle = CHSTYLE_2D_NET_SYMBOLS_PERCENT;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_STRIPE:
//STRIP001 			eStyle = CHSTYLE_3D_STRIPE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_COLUMN:
//STRIP001 			eStyle = CHSTYLE_3D_COLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_COLUMN_FLAT:
//STRIP001 			eStyle = CHSTYLE_3D_FLATCOLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_COLUMN_FLAT_STACKED:
//STRIP001 			eStyle = CHSTYLE_3D_STACKEDFLATCOLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_COLUMN_FLAT_PERCENT:
//STRIP001 			eStyle = CHSTYLE_3D_PERCENTFLATCOLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_AREA:
//STRIP001 			eStyle = CHSTYLE_3D_AREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_AREA_STACKED:
//STRIP001 			eStyle = CHSTYLE_3D_STACKEDAREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_AREA_PERCENT:
//STRIP001 			eStyle = CHSTYLE_3D_PERCENTAREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_PIE:
//STRIP001 			eStyle = CHSTYLE_3D_PIE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_DONUT1 :
//STRIP001 			eStyle = CHSTYLE_2D_DONUT1;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_DONUT2 :
//STRIP001 			eStyle = CHSTYLE_2D_DONUT2;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_BAR :
//STRIP001 			eStyle = CHSTYLE_3D_BAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_BAR_FLAT :
//STRIP001 			eStyle = CHSTYLE_3D_FLATBAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_BAR_FLAT_STACKED :
//STRIP001 			eStyle = CHSTYLE_3D_STACKEDFLATBAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_3D_BAR_FLAT_PERCENT :
//STRIP001 			eStyle = CHSTYLE_3D_PERCENTFLATBAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_CUBIC_SPLINE :
//STRIP001 			eStyle = CHSTYLE_2D_CUBIC_SPLINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_CUBIC_SPLINE_SYMBOL :
//STRIP001 			eStyle = CHSTYLE_2D_CUBIC_SPLINE_SYMBOL;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_B_SPLINE :
//STRIP001 			eStyle = CHSTYLE_2D_B_SPLINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_B_SPLINE_SYMBOL :
//STRIP001 			eStyle = CHSTYLE_2D_B_SPLINE_SYMBOL;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_CUBIC_SPLINE_XY :
//STRIP001 			eStyle = CHSTYLE_2D_CUBIC_SPLINE_XY;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_CUBIC_SPLINE_SYMBOL_XY :
//STRIP001 			eStyle = CHSTYLE_2D_CUBIC_SPLINE_SYMBOL_XY;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_B_SPLINE_XY :
//STRIP001 			eStyle = CHSTYLE_2D_B_SPLINE_XY;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_B_SPLINE_SYMBOL_XY :
//STRIP001 			eStyle = CHSTYLE_2D_B_SPLINE_SYMBOL_XY;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_STOCK_1:
//STRIP001 			eStyle = CHSTYLE_2D_STOCK_1;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_STOCK_2:
//STRIP001 			eStyle = CHSTYLE_2D_STOCK_2;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_STOCK_3:
//STRIP001 			eStyle = CHSTYLE_2D_STOCK_3;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_STOCK_4:
//STRIP001 			eStyle = CHSTYLE_2D_STOCK_4;
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			eStyle = CHSTYLE_2D_COLUMN;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	eOldStyle			= pDoc->ChartStyle();
//STRIP001 	long nOldShapeType	= pDoc->GetChartShapeType();
//STRIP001 
//STRIP001 	if(nShapeType != nOldShapeType)
//STRIP001 	{
//STRIP001 		SfxItemSet aSet( pDoc->GetPool(), SCHATTR_STYLE_SHAPE, SCHATTR_STYLE_SHAPE );
//STRIP001 		aSet.Put( SfxInt32Item( SCHATTR_STYLE_SHAPE, nShapeType ) );
//STRIP001 		pDoc->PutDataRowAttrAll(aSet);
//STRIP001 	}
//STRIP001 	if(eStyle!=eOldStyle)
//STRIP001 	{
//STRIP001 //		The following is done now in ChangeChart because XML loading needs to
//STRIP001 //		do it too and already calls ChangeChart.
//STRIP001 /*		// BM #67923#
//STRIP001 		if( pOutSet )	// means we have a new chart
//STRIP001 		{
//STRIP001 			bYAutoOrigin = (pDoc->IsXYChart( &eStyle ) ||
//STRIP001 							eVariant == CHVARIANT_2D_STOCK_1 ||
//STRIP001 							eVariant == CHVARIANT_2D_STOCK_2 );
//STRIP001 
//STRIP001 			SfxItemSet aAttr( pDoc->GetPool(), SCHATTR_AXIS_AUTO_ORIGIN, SCHATTR_AXIS_AUTO_ORIGIN );
//STRIP001 			aAttr.Put( SfxBoolItem( SCHATTR_AXIS_AUTO_ORIGIN, bYAutoOrigin ));
//STRIP001 			ChartAxis* pYAxis = pDoc->GetAxis( CHOBJID_DIAGRAM_Y_AXIS );
//STRIP001 			if( pYAxis )
//STRIP001 			{
//STRIP001 				pYAxis->SetAttributes( aAttr );
//STRIP001 			}
//STRIP001 		}
//STRIP001 */
//STRIP001 		if( GetReduceStyle(eOldStyle) != GetReduceStyle(eStyle) )
//STRIP001 			ReduceDataAgain(TRUE);
//STRIP001 		pDoc->ChangeChart(eStyle);
//STRIP001 	}
//STRIP001 
//STRIP001 	BuildChart();
//STRIP001 
//STRIP001 	pCT_PREVIEW->Invalidate();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 ChType SchDiagramAutoPilotDlg::GetTypeFromStyle( SvxChartStyle eStyle )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	ChType eResult = CHTYPE_2D_LINE;
//STRIP001 
//STRIP001 	switch( eStyle )
//STRIP001 	{
//STRIP001 		case CHSTYLE_2D_LINE:
//STRIP001 		case CHSTYLE_2D_STACKEDLINE:
//STRIP001 		case CHSTYLE_2D_PERCENTLINE:
//STRIP001 		case CHSTYLE_2D_LINESYMBOLS:
//STRIP001 		case CHSTYLE_2D_STACKEDLINESYM:
//STRIP001 		case CHSTYLE_2D_PERCENTLINESYM:
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE :
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE_SYMBOL :
//STRIP001 		case CHSTYLE_2D_B_SPLINE :
//STRIP001 		case CHSTYLE_2D_B_SPLINE_SYMBOL :
//STRIP001 			eResult = CHTYPE_2D_LINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_COLUMN:
//STRIP001 		case CHSTYLE_2D_STACKEDCOLUMN:
//STRIP001 		case CHSTYLE_2D_PERCENTCOLUMN:
//STRIP001         case CHSTYLE_2D_LINE_COLUMN:
//STRIP001         case CHSTYLE_2D_LINE_STACKEDCOLUMN:
//STRIP001 			eResult = CHTYPE_2D_COLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_BAR:
//STRIP001 		case CHSTYLE_2D_STACKEDBAR:
//STRIP001 		case CHSTYLE_2D_PERCENTBAR:
//STRIP001 			eResult = CHTYPE_2D_BAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_AREA:
//STRIP001 		case CHSTYLE_2D_STACKEDAREA:
//STRIP001 		case CHSTYLE_2D_PERCENTAREA:
//STRIP001 			eResult = CHTYPE_2D_AREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PIE:
//STRIP001 		case CHSTYLE_2D_DONUT1:
//STRIP001 		case CHSTYLE_2D_DONUT2:
//STRIP001 		case CHSTYLE_2D_PIE_SEGOF1:
//STRIP001 		case CHSTYLE_2D_PIE_SEGOFALL:
//STRIP001 			eResult = CHTYPE_2D_PIE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_XYSYMBOLS:
//STRIP001 		case CHSTYLE_2D_XY:
//STRIP001 		case CHSTYLE_2D_XY_LINE:
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE_XY :
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE_SYMBOL_XY :
//STRIP001 		case CHSTYLE_2D_B_SPLINE_XY :
//STRIP001 		case CHSTYLE_2D_B_SPLINE_SYMBOL_XY :
//STRIP001 			eResult  = CHTYPE_2D_XY;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS :
//STRIP001 		case CHSTYLE_2D_NET_STACK :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_STACK :
//STRIP001 		case CHSTYLE_2D_NET_PERCENT :
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_PERCENT :
//STRIP001 			eResult =  CHTYPE_2D_NET;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_STRIPE:
//STRIP001 			eResult = CHTYPE_3D_STRIPE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_COLUMN:
//STRIP001 		case CHSTYLE_3D_FLATCOLUMN:
//STRIP001 		case CHSTYLE_3D_STACKEDFLATCOLUMN:
//STRIP001 		case CHSTYLE_3D_PERCENTFLATCOLUMN:
//STRIP001 			eResult = CHTYPE_3D_COLUMN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_AREA:
//STRIP001 		case CHSTYLE_3D_STACKEDAREA:
//STRIP001 		case CHSTYLE_3D_PERCENTAREA:
//STRIP001 			eResult = CHTYPE_3D_AREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_BAR:
//STRIP001 		case CHSTYLE_3D_FLATBAR:
//STRIP001 		case CHSTYLE_3D_STACKEDFLATBAR:
//STRIP001 		case CHSTYLE_3D_PERCENTFLATBAR:
//STRIP001 			eResult = CHTYPE_3D_BAR;
//STRIP001 			break;
//STRIP001 
//STRIP001 //		case CHSTYLE_3D_SURFACE:
//STRIP001 		case CHSTYLE_3D_PIE:
//STRIP001 			eResult = CHTYPE_3D_PIE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STOCK_1:
//STRIP001 		case CHSTYLE_2D_STOCK_2:
//STRIP001 		case CHSTYLE_2D_STOCK_3:
//STRIP001 		case CHSTYLE_2D_STOCK_4:
//STRIP001 			eResult = CHTYPE_2D_STOCK;
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			eResult = CHTYPE_2D_LINE;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	return eResult;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, CheckBoxClickHdl, CheckBox*, pCheck )
//STRIP001 {
//STRIP001 	BOOL bUpdate = (! bNoText);
//STRIP001 
//STRIP001 	if( pCheck == pCB_2_YGRID )
//STRIP001 	{
//STRIP001 		pDoc->ShowXGridMain() = pCB_2_YGRID->IsChecked ();
//STRIP001 		bUpdate = TRUE;
//STRIP001 	}
//STRIP001 	else if( pCheck == pCB_2_XGRID )
//STRIP001 	{
//STRIP001 		pDoc->ShowYGridMain() = pCB_2_XGRID->IsChecked ();
//STRIP001 		bUpdate = TRUE;
//STRIP001 	}
//STRIP001 	else if( pCheck == pCB_2_ZGRID )
//STRIP001 	{
//STRIP001 		pDoc->ShowZGridMain() = pCB_2_ZGRID->IsChecked ();
//STRIP001 		bUpdate = TRUE;
//STRIP001 	}
//STRIP001 	else if( pCheck == pCB_3_XTEXT )
//STRIP001 		bShowXAxisTitle = pCB_3_XTEXT->IsChecked();
//STRIP001 	else if( pCheck == pCB_3_YTEXT )
//STRIP001 		bShowYAxisTitle = pCB_3_YTEXT->IsChecked();
//STRIP001 	else if( pCheck == pCB_3_ZTEXT )
//STRIP001 		bShowZAxisTitle = pCB_3_ZTEXT->IsChecked();
//STRIP001 	else if( pCheck == pCB_3_TEXTTITLE )
//STRIP001 		bShowMainTitle = pCB_3_TEXTTITLE->IsChecked();
//STRIP001     else if( pCheck == pCB_3_LEGEND )
//STRIP001         bShowLegend = pCB_3_LEGEND->IsChecked();
//STRIP001 
//STRIP001 	pET_3_TEXTRUBRIK->Enable( pCB_3_XTEXT->IsEnabled() && bShowXAxisTitle );
//STRIP001 	pET_3_TEXTSIZE->Enable(	pCB_3_YTEXT->IsEnabled() && bShowYAxisTitle );
//STRIP001 	pET_3_TEXTSECOND->Enable( pCB_3_ZTEXT->IsEnabled() && bShowZAxisTitle );
//STRIP001 	pET_3_TEXTTITLE->Enable( pCB_3_TEXTTITLE->IsEnabled() && bShowMainTitle );
//STRIP001 
//STRIP001 	if( bUpdate )
//STRIP001 	{
//STRIP001 		BuildChart();
//STRIP001 		pCT_PREVIEW->Invalidate();
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::EnableOverlap()
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	SvxChartStyle eStyle =
//STRIP001 		(SvxChartStyle)(pCT_2_CHARTVARIANT->GetSelectItemId()-1);
//STRIP001 	ChVariant eVariant = (ChVariant)(pCT_2_CHARTVARIANT->GetSelectItemId());
//STRIP001 
//STRIP001 	pET_3_TEXTSECOND->Enable (FALSE);
//STRIP001 	pCB_2_XGRID->Enable(TRUE);
//STRIP001 	pCB_2_YGRID->Enable(TRUE);
//STRIP001 	pCB_2_ZGRID->Enable (FALSE);
//STRIP001 	pET_3_TEXTRUBRIK->Enable(TRUE);
//STRIP001 	pET_3_TEXTSIZE->Enable(TRUE);
//STRIP001 	pET_3_TEXTSECOND->Enable(TRUE);
//STRIP001 	pCB_3_XTEXT->Enable(TRUE);
//STRIP001 	pCB_3_YTEXT->Enable(TRUE);
//STRIP001 	pCB_3_ZTEXT->Enable (FALSE);
//STRIP001 
//STRIP001 	BOOL bIs3D = FALSE;
//STRIP001 
//STRIP001 	switch (eVariant)
//STRIP001 	{
//STRIP001 		case CHVARIANT_3D_STRIPE :
//STRIP001 		case CHVARIANT_3D_COLUMN :
//STRIP001 		case CHVARIANT_3D_COLUMN_FLAT :
//STRIP001 		case CHVARIANT_3D_COLUMN_FLAT_STACKED :
//STRIP001 		case CHVARIANT_3D_COLUMN_FLAT_PERCENT :
//STRIP001 		case CHVARIANT_3D_AREA :
//STRIP001 		case CHVARIANT_3D_AREA_STACKED :
//STRIP001 		case CHVARIANT_3D_AREA_PERCENT :
//STRIP001 		case CHVARIANT_3D_SURFACE :
//STRIP001 		case CHVARIANT_3D_XYZ :
//STRIP001 		case CHVARIANT_3D_XYZ_SYMB :
//STRIP001 		case CHVARIANT_3D_BAR :
//STRIP001 		case CHVARIANT_3D_BAR_FLAT :
//STRIP001 		case CHVARIANT_3D_BAR_FLAT_STACKED :
//STRIP001 		case CHVARIANT_3D_BAR_FLAT_PERCENT :
//STRIP001 			pCB_2_ZGRID->Enable(TRUE);
//STRIP001 			pCB_3_ZTEXT->Enable(TRUE);
//STRIP001 			pET_3_TEXTSECOND->Enable(TRUE);
//STRIP001 			bIs3D = TRUE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_PIE :
//STRIP001 		case CHVARIANT_3D_PIE :
//STRIP001 		case CHVARIANT_2D_DONUT1 :
//STRIP001 		case CHVARIANT_2D_DONUT2 :
//STRIP001 		case CHVARIANT_2D_PIE_SEGOFS_1 :
//STRIP001 		case CHVARIANT_2D_PIE_SEGOFS_ALL :
//STRIP001 			pCB_2_XGRID->Enable (FALSE);
//STRIP001 			pCB_2_YGRID->Enable (FALSE);
//STRIP001 			pCB_2_ZGRID->Enable (FALSE);
//STRIP001 			pET_3_TEXTRUBRIK->Enable (FALSE);
//STRIP001 			pET_3_TEXTSIZE->Enable (FALSE);
//STRIP001 			pET_3_TEXTSECOND->Enable (FALSE);
//STRIP001 			pCB_3_XTEXT->Enable (FALSE);
//STRIP001 			pCB_3_YTEXT->Enable (FALSE);
//STRIP001 			pCB_3_ZTEXT->Enable (FALSE);
//STRIP001 
//STRIP001 			if (eStyle == CHVARIANT_3D_PIE) bIs3D = TRUE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_NET :
//STRIP001 		case CHVARIANT_2D_NETSYMB :
//STRIP001 		case CHVARIANT_2D_NET_STACK :
//STRIP001 		case CHVARIANT_2D_NETSYMB_STACK :
//STRIP001 		case CHVARIANT_2D_NET_PERCENT :
//STRIP001 		case CHVARIANT_2D_NETSYMB_PERCENT :
//STRIP001 			pCB_2_XGRID->Enable (FALSE);
//STRIP001 			pCB_2_ZGRID->Enable (FALSE);
//STRIP001 			pET_3_TEXTRUBRIK->Enable (FALSE);
//STRIP001 			pET_3_TEXTSIZE->Enable (FALSE);
//STRIP001 			pET_3_TEXTSECOND->Enable (FALSE);
//STRIP001 			pCB_3_XTEXT->Enable (FALSE);
//STRIP001 			pCB_3_YTEXT->Enable (FALSE);
//STRIP001 			pCB_3_ZTEXT->Enable (FALSE);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHVARIANT_2D_COLUMN :
//STRIP001 		case CHVARIANT_2D_BAR :
//STRIP001 			break;
//STRIP001 
//STRIP001 		default :
//STRIP001 			;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bIs3D)
//STRIP001 	{
//STRIP001 		pCB_2_ZGRID->Enable (FALSE);
//STRIP001 		pET_3_TEXTSECOND->Enable (FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	 // [FG] Hier soll beim ersten Klick entschieden werden, wie die Daten eines XY-Charts interpretiert
//STRIP001 	 // werden sollen. (Sollen die Daten Spalten oder Zeilenweise interpretiert werden?)
//STRIP001 	 // Der Wechsel bei jedem weiterem Click wurde deaktiviert, da es fuer den Benutzer nicht
//STRIP001 	 // einsichtig ist warum ein
//STRIP001 	 // Klick auf das XY-Diagramm Symbol die Interpretation der Anordnung der Daten aendern soll.
//STRIP001 	 // Dieser Effekt ist nur bei XY-Charts mit 2 Spalten und bei 3D-BalkenCharts mit mehreren
//STRIP001 	 // Datenreihen wichtig.
//STRIP001 
//STRIP001 	 CheckBoxClickHdl( 0 );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, PreviewDelayHdl, Timer *, pTimer )
//STRIP001 {
//STRIP001 	DBG_CHKTHIS( SchDiagramAutoPilotDlg, NULL );
//STRIP001 
//STRIP001 	pCT_PREVIEW->Show();
//STRIP001 	ScalePreview();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::FillOutputItemSet()
//STRIP001 {
//STRIP001 	if( pOutSet )
//STRIP001 	{
//STRIP001 		if( nShapeType != CHART_SHAPE3D_ANY )
//STRIP001 		{
//STRIP001 			pOutSet->Put(SfxInt32Item( SCHATTR_STYLE_SHAPE, nShapeType) );
//STRIP001 			pOutSet->Put(SfxInt32Item(  CHATTR_STYLE_SHAPE, nShapeType) );
//STRIP001 			CHART_TRACE(" SchDiagramAutoPilotDlg::FillOutputItemSet 3D shape Set");
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pOutSet->ClearItem(SCHATTR_STYLE_SHAPE);
//STRIP001 			pOutSet->ClearItem(CHATTR_STYLE_SHAPE);
//STRIP001 		}
//STRIP001 		pOutSet->Put( SvxChartStyleItem( pDoc->ChartStyle(), CHATTR_DIAGRAM_STYLE ) );
//STRIP001 		pOutSet->Put( SvxChartLegendPosItem( bShowLegend
//STRIP001 												 ? eLegendPos
//STRIP001 												 : CHLEGEND_NONE,
//STRIP001 											 CHATTR_LEGEND_POS));
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_TITLE_SHOW_MAIN, bShowMainTitle ) );
//STRIP001 		pOutSet->Put( SfxStringItem( CHATTR_TITLE_MAIN, pDoc->MainTitle() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_TITLE_SHOW_SUB, bShowSubTitle ) );
//STRIP001 		pOutSet->Put( SfxStringItem( CHATTR_TITLE_SUB, pDoc->SubTitle() ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_TITLE_SHOW_X_AXIS, bShowXAxisTitle ) );
//STRIP001 		pOutSet->Put( SfxStringItem( CHATTR_TITLE_X_AXIS, pDoc->XAxisTitle() ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_TITLE_SHOW_Y_AXIS, bShowYAxisTitle ) );
//STRIP001 		pOutSet->Put( SfxStringItem( CHATTR_TITLE_Y_AXIS, pDoc->YAxisTitle() ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_TITLE_SHOW_Z_AXIS, bShowZAxisTitle ) );
//STRIP001 		pOutSet->Put( SfxStringItem( CHATTR_TITLE_Z_AXIS, pDoc->ZAxisTitle() ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_AXIS, pDoc->ShowXAxis() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_MAIN, pDoc->ShowXGridMain() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_HELP, pDoc->ShowXGridHelp() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_DESCR, bShowXDescr ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_AXIS, pDoc->ShowYAxis() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_MAIN, pDoc->ShowYGridMain() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_HELP, pDoc->ShowYGridHelp() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_DESCR, bShowYDescr ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_AXIS, pDoc->ShowZAxis() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_MAIN, pDoc->ShowZGridMain() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_HELP, pDoc->ShowZGridHelp() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_DESCR, bShowZDescr ) );
//STRIP001 
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_DATA_SWITCH, pDoc->IsSwitchData() ) );
//STRIP001 		pOutSet->Put( SfxBoolItem( CHATTR_AXIS_AUTO_ORIGIN, bYAutoOrigin ) );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 ChVariant SchDiagramAutoPilotDlg::TranslateFromModel (SvxChartStyle eStyle)
//STRIP001 {
//STRIP001 	switch( eStyle )
//STRIP001 	{
//STRIP001 		case CHSTYLE_2D_LINE:
//STRIP001 			return CHVARIANT_2D_LINE;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STACKEDLINE:
//STRIP001 			return CHVARIANT_2D_LINE_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PERCENTLINE:
//STRIP001 			return CHVARIANT_2D_LINE_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_LINESYMBOLS:
//STRIP001 			return CHVARIANT_2D_LINESYMB;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STACKEDLINESYM:
//STRIP001 			return CHVARIANT_2D_LINESYMB_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PERCENTLINESYM:
//STRIP001 			return CHVARIANT_2D_LINESYMB_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_COLUMN:
//STRIP001 			return CHVARIANT_2D_COLUMN;
//STRIP001 
//STRIP001         case CHSTYLE_2D_LINE_COLUMN:
//STRIP001             return CHVARIANT_2D_LINE_COLUMN;
//STRIP001 
//STRIP001         case CHSTYLE_2D_LINE_STACKEDCOLUMN:
//STRIP001             return CHVARIANT_2D_LINE_STACKEDCOLUMN;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STACKEDCOLUMN:
//STRIP001 			return CHVARIANT_2D_COLUMN_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PERCENTCOLUMN:
//STRIP001 			return CHVARIANT_2D_COLUMN_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_BAR:
//STRIP001 			return CHVARIANT_2D_BAR;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STACKEDBAR:
//STRIP001 			return CHVARIANT_2D_BAR_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PERCENTBAR:
//STRIP001 			return CHVARIANT_2D_BAR_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_AREA:
//STRIP001 			return CHVARIANT_2D_AREA;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STACKEDAREA:
//STRIP001 			return CHVARIANT_2D_AREA_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PERCENTAREA:
//STRIP001 			return CHVARIANT_2D_AREA_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PIE:
//STRIP001 			return CHVARIANT_2D_PIE;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PIE_SEGOF1:
//STRIP001 			return CHVARIANT_2D_PIE_SEGOFS_1;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_PIE_SEGOFALL:
//STRIP001 			return CHVARIANT_2D_PIE_SEGOFS_ALL;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_XYSYMBOLS:
//STRIP001 			return CHVARIANT_2D_XY_SYMB;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_XY:
//STRIP001 			return CHVARIANT_2D_XY;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_XY_LINE:
//STRIP001 			return CHVARIANT_2D_XY_LINE;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET:
//STRIP001 			return CHVARIANT_2D_NET;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS:
//STRIP001 			return CHVARIANT_2D_NETSYMB;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET_STACK:
//STRIP001 			return CHVARIANT_2D_NET_STACK;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_STACK:
//STRIP001 			return CHVARIANT_2D_NETSYMB_STACK;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET_PERCENT:
//STRIP001 			return CHVARIANT_2D_NET_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_NET_SYMBOLS_PERCENT:
//STRIP001 			return CHVARIANT_2D_NETSYMB_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_STRIPE:
//STRIP001 			return CHVARIANT_3D_STRIPE;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_COLUMN:
//STRIP001 			return CHVARIANT_3D_COLUMN;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_FLATCOLUMN:
//STRIP001 			return CHVARIANT_3D_COLUMN_FLAT;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_STACKEDFLATCOLUMN:
//STRIP001 			return CHVARIANT_3D_COLUMN_FLAT_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_PERCENTFLATCOLUMN:
//STRIP001 			return CHVARIANT_3D_COLUMN_FLAT_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_AREA:
//STRIP001 			return CHVARIANT_3D_AREA;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_STACKEDAREA:
//STRIP001 			return CHVARIANT_3D_AREA_STACKED;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_PERCENTAREA:
//STRIP001 			return CHVARIANT_3D_AREA_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_PIE:
//STRIP001 			return CHVARIANT_3D_PIE;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_DONUT1:
//STRIP001 			return CHVARIANT_2D_DONUT1;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_DONUT2:
//STRIP001 			return CHVARIANT_2D_DONUT2;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_BAR:
//STRIP001 			return CHVARIANT_3D_BAR;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_FLATBAR:
//STRIP001 			return CHVARIANT_3D_BAR_FLAT;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_STACKEDFLATBAR:
//STRIP001 			return CHVARIANT_3D_BAR_FLAT_STACKED;
//STRIP001 
//STRIP001 		case CHSTYLE_3D_PERCENTFLATBAR:
//STRIP001 			return CHVARIANT_3D_BAR_FLAT_PERCENT;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE :
//STRIP001 			return CHVARIANT_2D_CUBIC_SPLINE;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE_SYMBOL :
//STRIP001 			return CHVARIANT_2D_CUBIC_SPLINE_SYMBOL;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_B_SPLINE :
//STRIP001 			return CHVARIANT_2D_B_SPLINE;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_B_SPLINE_SYMBOL :
//STRIP001 			return CHVARIANT_2D_B_SPLINE_SYMBOL;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE_XY :
//STRIP001 			return CHVARIANT_2D_CUBIC_SPLINE_XY;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_CUBIC_SPLINE_SYMBOL_XY :
//STRIP001 			return CHVARIANT_2D_CUBIC_SPLINE_SYMBOL_XY;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_B_SPLINE_XY :
//STRIP001 			return CHVARIANT_2D_B_SPLINE_XY;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_B_SPLINE_SYMBOL_XY :
//STRIP001 			return CHVARIANT_2D_B_SPLINE_SYMBOL_XY;
//STRIP001 
//STRIP001 		case CHSTYLE_2D_STOCK_1:
//STRIP001 			return CHVARIANT_2D_STOCK_1;
//STRIP001 		case CHSTYLE_2D_STOCK_2:
//STRIP001 			return CHVARIANT_2D_STOCK_2;
//STRIP001 		case CHSTYLE_2D_STOCK_3:
//STRIP001 			return CHVARIANT_2D_STOCK_3;
//STRIP001 		case CHSTYLE_2D_STOCK_4:
//STRIP001 			return CHVARIANT_2D_STOCK_4;
//STRIP001 
//STRIP001 		default :
//STRIP001 			return CHVARIANT_2D_COLUMN;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 IMPL_LINK( SchDiagramAutoPilotDlg, NoTextClickHdl, Button *, pButton )
//STRIP001 {
//STRIP001 	bNoText = !aCB_NOTEXT.IsChecked ();
//STRIP001 	BuildChart();
//STRIP001 	pCT_PREVIEW->Invalidate();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::NewAxisText( const ChType & eOldType,
//STRIP001                                           const ChType & eNewType,
//STRIP001                                           bool bChangeRowCol )
//STRIP001 {
//STRIP001     // change x-axis title for scatter charts (XY)
//STRIP001     if( IsXAxisTitleDefault( eOldType == CHTYPE_2D_XY ))
//STRIP001     {
//STRIP001         String aTitle;
//STRIP001 
//STRIP001         if( eNewType == CHTYPE_2D_XY )
//STRIP001         {
//STRIP001             if( bChangeRowCol )
//STRIP001                 aTitle = pDoc->ColText( 0 );
//STRIP001             else
//STRIP001                 aTitle = pDoc->RowText( 0 );
//STRIP001         }
//STRIP001         else
//STRIP001             aTitle = String( SchResId( STR_DIAGRAM_TITLE_X_AXIS ) );
//STRIP001 
//STRIP001         pET_3_TEXTRUBRIK->SetText( aTitle );
//STRIP001         pET_3_TEXTRUBRIK->ClearModifyFlag();
//STRIP001         pDoc->XAxisTitle() = aTitle;
//STRIP001     }
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------------
//STRIP001 void SchDiagramAutoPilotDlg::ChangeColRow ()
//STRIP001 {
//STRIP001 	BOOL bVal = pDoc->IsSwitchData();
//STRIP001 
//STRIP001 	BOOL bOldVal=bVal;
//STRIP001 
//STRIP001 	int number_of_columns = pDoc->GetColCount();
//STRIP001 	int number_of_rows    = pDoc->GetRowCount();
//STRIP001 
//STRIP001 // [FG] SwitchData ist eine Funktion, die nur ein BOOLEAN gleich TRUE oder FALSE setzt
//STRIP001 //      In diesem Fall werden die Daten nicht kopiert, sondern die Fuktionen liefern in Abhaengigkeit dieses
//STRIP001 //      Schalters Daten zurueck. Mit anderen Worten falls, SwitchData=TRUE dann werden die Daten nur
//STRIP001 //      "geswitched" interpretiert und nicht wirklich geswitched. Eine einmal getroffene Einstellung muss
//STRIP001 //      beibehalten werden.
//STRIP001 
//STRIP001 	//   [TVM] Kommentar und Code bleiben mir ein absolutes Raetsel....
//STRIP001 
//STRIP001    if (pDoc->GetColCount () == 1)
//STRIP001 	{
//STRIP001 		bVal = FALSE;
//STRIP001 		pDoc->SetSwitchData (FALSE);
//STRIP001 	}
//STRIP001 	else if ((pDoc->GetRowCount () == 1) || ((pDoc->GetColCount () == 2) && (pDoc->GetRowCount () >= 4)))
//STRIP001 		 {
//STRIP001 			 bVal = TRUE;
//STRIP001 			 pDoc->SetSwitchData (TRUE);
//STRIP001 		 }
//STRIP001 
//STRIP001 
//STRIP001 	aRB_DATAROWS.Check( ! bVal );
//STRIP001 	aRB_DATACOLS.Check( bVal );
//STRIP001 
//STRIP001 	//eventuell muss nun anders reduziert werden,siehe ChangeChartData()
//STRIP001 	if(bVal != bOldVal)
//STRIP001 		ReduceDataAgain();
//STRIP001 }
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::FillValueSets()
//STRIP001 {
//STRIP001     bool bIsHighContrast = ( true && GetDisplayBackground().GetColor().IsDark() );
//STRIP001 
//STRIP001     // primary chart type
//STRIP001     if( pCT_1_CHARTTYPE->GetItemCount() == 0 )
//STRIP001     {
//STRIP001         // 2D
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_LINE, SELECT_BITMAP( BMP_LINES_2D ),
//STRIP001                                      String( SchResId( STR_LINES )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_AREA, SELECT_BITMAP( BMP_AREAS_2D ),
//STRIP001                                      String(SchResId(STR_AREAS)));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_COLUMN, SELECT_BITMAP( BMP_COLUMNS_2D ),
//STRIP001                                      String( SchResId( STR_COLUMNS )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_BAR, SELECT_BITMAP( BMP_BARS_2D ),
//STRIP001                                      String( SchResId( STR_BARS )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_PIE, SELECT_BITMAP( BMP_CIRCLES_2D ),
//STRIP001                                      String( SchResId( STR_CIRCLES )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_XY, SELECT_BITMAP( BMP_XYSYMB_2D ),
//STRIP001                                      String( SchResId( STR_XY )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_NET, SELECT_BITMAP( BMP_NET_2D ),
//STRIP001                                      String( SchResId( STR_NET )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_2D_STOCK, SELECT_BITMAP( BMP_STOCK_2 ),
//STRIP001                                      String( SchResId( STR_STOCK )));
//STRIP001 	    // 3D
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_3D_STRIPE, SELECT_BITMAP( BMP_LINES_3D ),
//STRIP001                                      String( SchResId( STR_LINES )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_3D_AREA, SELECT_BITMAP( BMP_AREAS_3D_1 ),
//STRIP001                                      String( SchResId( STR_AREAS )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_3D_BAR, SELECT_BITMAP( BMP_BARS_3D_1 ),
//STRIP001                                      String( SchResId( STR_BARS )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_3D_COLUMN, SELECT_BITMAP( BMP_COLUMNS_3D_1 ),
//STRIP001                                      String( SchResId( STR_COLUMNS )));
//STRIP001 	    pCT_1_CHARTTYPE->InsertItem( CHTYPE_3D_PIE, SELECT_BITMAP( BMP_CIRCLES_3D ),
//STRIP001                                      String( SchResId( STR_CIRCLES )));
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         // 2D
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_LINE, SELECT_BITMAP( BMP_LINES_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_AREA, SELECT_BITMAP( BMP_AREAS_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_COLUMN, SELECT_BITMAP( BMP_COLUMNS_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_BAR, SELECT_BITMAP( BMP_BARS_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_PIE, SELECT_BITMAP( BMP_CIRCLES_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_XY, SELECT_BITMAP( BMP_XYSYMB_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_NET, SELECT_BITMAP( BMP_NET_2D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_2D_STOCK, SELECT_BITMAP( BMP_STOCK_2 ));
//STRIP001 	    // 3D
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_3D_STRIPE, SELECT_BITMAP( BMP_LINES_3D ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_3D_AREA, SELECT_BITMAP( BMP_AREAS_3D_1 ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_3D_BAR, SELECT_BITMAP( BMP_BARS_3D_1 ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_3D_COLUMN, SELECT_BITMAP( BMP_COLUMNS_3D_1 ));
//STRIP001 	    pCT_1_CHARTTYPE->SetItemImage( CHTYPE_3D_PIE, SELECT_BITMAP( BMP_CIRCLES_3D ));
//STRIP001     }
//STRIP001 
//STRIP001     // sub-type
//STRIP001     USHORT nId = pCT_1_CHARTTYPE->GetSelectItemId();
//STRIP001     if( nId != 0 )
//STRIP001     {
//STRIP001         SelectVariantSet( static_cast< ChType >( nId ), CHVARIANT_INVALID );
//STRIP001     }
//STRIP001 }
//STRIP001 
//STRIP001 void SchDiagramAutoPilotDlg::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001     ModalDialog::DataChanged( rDCEvt );
//STRIP001 
//STRIP001     if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) && (rDCEvt.GetFlags() & SETTINGS_STYLE) )
//STRIP001         FillValueSets();
//STRIP001 }
//STRIP001 
//STRIP001 bool SchDiagramAutoPilotDlg::IsXAxisTitleDefault( bool bIsXYChart ) const
//STRIP001 {
//STRIP001     return bIsXYChart
//STRIP001         ? ( pDoc->RowText( 0 ) == pET_3_TEXTRUBRIK->GetText() )
//STRIP001         : ( String( SchResId( STR_DIAGRAM_TITLE_X_AXIS )) == pET_3_TEXTRUBRIK->GetText() );
//STRIP001 }
}
