/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_fuslshw4.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 00:19:35 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop

#if defined( WIN ) || defined( WNT )
#include <tools/svwin.h>
#endif

#include <stdlib.h>
#include <math.h>
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #include <bf_svx/xoutx.hxx>
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #ifndef _SVDOATTR_HXX //autogen
// auto strip #include <bf_svx/svdoattr.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX //autogen
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif

#define FUSLIDESHOW_INTERN
// auto strip #include "fuslshow.hxx"
// auto strip #include "mover.hxx"
// auto strip #include "fader.hxx"
#include "strings.hrc"
// auto strip #include "drawdoc.hxx"
// auto strip #include "frmview.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "sdpage.hxx"
#include "docshell.hxx"
// auto strip #include "sdresid.hxx"
#include "glob.hrc"
#include <bf_svx/svxids.hrc>
// auto strip #include "anminfo.hxx"
// auto strip #include "cusshow.hxx"

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #include "showview.hxx"
// auto strip #include "drawview.hxx"

#ifndef _SVDVIEW_HXX //autogen
#include <bf_svx/svdview.hxx>
#endif
namespace binfilter {


/*************************************************************************
|*
|*    Vergleichsfkt. fuer QSort
|*
\************************************************************************/

/*N*/ struct SortStruct
/*N*/ {
/*N*/ 	SdrObject*	pObj;
/*N*/ 	ULONG		nOrder;
/*N*/ };

/*N*/ typedef SortStruct	SORT;
/*N*/ typedef SORT*		PSORT;

/*N*/ extern "C" int __LOADONCALLAPI SortFunc( const void* p1, const void* p2 )
/*N*/ {
/*N*/ 	const PSORT pCmp1 = (const PSORT) p1;
/*N*/ 	const PSORT pCmp2 = (const PSORT) p2;
/*N*/ 
/*N*/ 	return ( pCmp1->nOrder < pCmp2->nOrder ? -1 : pCmp1->nOrder > pCmp2->nOrder ? 1 : 0 );
/*N*/ }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::HandleError( const USHORT nStringId )
//STRIP001 {
//STRIP001 	ErrorBox( pShowWindow, WB_OK, String( SdResId( nStringId ) ) ).Execute();
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 /*N*/ void FuSlideShow::Terminate()
//STRIP001 /*N*/ {
//STRIP001 /*N*/ 	nMagic = 0;
//STRIP001 /*N*/ 
//STRIP001 /*N*/ 	UnlockDrawViewShell( TRUE );
//STRIP001 /*N*/ 	pFader->Terminate();
//STRIP001 /*N*/ 	pMover->Terminate();
//STRIP001 /*N*/ 	bTerminated = TRUE;
//STRIP001 /*N*/ 	aTimer.Stop();
//STRIP001 /*N*/ 
//STRIP001 /*N*/ 	while( nPushCount )
//STRIP001 /*N*/ 	{
//STRIP001 /*N*/ 		pShowWindow->Pop();
//STRIP001 /*N*/ 		nPushCount--;
//STRIP001 /*N*/ 	}
//STRIP001 /*N*/ 
//STRIP001 /*N*/ 	JumpToPage( PAGE_NO_END );
//STRIP001 /*N*/ }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::InitPageModify()
//STRIP001 {
//STRIP001 	for( void* pObj = pCurAnimGraphs->First(); pObj; pObj = pCurAnimGraphs->Next() )
//STRIP001 		StopTextOrGraphicAnimation( (SdrObject*) pObj, FALSE );
//STRIP001 
//STRIP001 	pCurAnimGraphs->Clear(); 
//STRIP001 	pNextAnimGraphs->Clear(); 
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::LockDrawViewShell()
//STRIP001 {
//STRIP001 	nIgnoreInputSmph++;
//STRIP001 
//STRIP001 	if ( !bTerminated )
//STRIP001 	{
//STRIP001 		SdDrawViewShell* pShell = PTR_CAST( SdDrawViewShell, pDoc->GetDocSh()->GetViewShell() );
//STRIP001 
//STRIP001 		if( pShell )
//STRIP001 		{
//STRIP001 			pShell->LockInput();
//STRIP001 			nShellLockCount++;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxBindings& rBind = ( pViewShell ? pViewShell->GetViewFrame() : SfxViewFrame::Current() )->GetBindings();
//STRIP001 		
//STRIP001 	rBind.Invalidate( SID_CLOSEDOC );
//STRIP001 	rBind.Invalidate( SID_PRESENTATION );
//STRIP001 	rBind.Invalidate( SID_REHEARSE_TIMINGS );
//STRIP001 	rBind.Update( SID_CLOSEDOC );
//STRIP001 	rBind.Update( SID_PRESENTATION );
//STRIP001 	rBind.Update( SID_REHEARSE_TIMINGS );
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::UnlockDrawViewShell( BOOL bUnlockFull )
//STRIP001 {
//STRIP001 	if( bUnlockFull )
//STRIP001 		nIgnoreInputSmph = 0;
//STRIP001 	else if( nIgnoreInputSmph )
//STRIP001 		nIgnoreInputSmph--;
//STRIP001 
//STRIP001 	if ( !bTerminated && pDoc && pDoc->GetDocSh() )
//STRIP001 	{
//STRIP001 		SdDrawViewShell* pShell = PTR_CAST( SdDrawViewShell, pDoc->GetDocSh()->GetViewShell() );
//STRIP001 
//STRIP001 		if( pShell )
//STRIP001 		{
//STRIP001 			if( bUnlockFull )
//STRIP001 			{
//STRIP001 				for( ULONG i = 0UL; i < nShellLockCount; i++ )
//STRIP001 					pShell->UnlockInput();
//STRIP001 
//STRIP001 				nShellLockCount = 0UL;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pShell->UnlockInput();
//STRIP001 
//STRIP001 				if( nShellLockCount )
//STRIP001 					nShellLockCount--;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !nIgnoreInputSmph )
//STRIP001 	{
//STRIP001         SfxViewFrame* pViewFrame = pViewShell ? pViewShell->GetViewFrame() : SfxViewFrame::Current();
//STRIP001 
//STRIP001         if( pViewFrame )
//STRIP001         {
//STRIP001 		    SfxBindings& rBind = pViewFrame->GetBindings();
//STRIP001 
//STRIP001 		    rBind.Invalidate( SID_CLOSEDOC );
//STRIP001 		    rBind.Invalidate( SID_PRESENTATION );
//STRIP001 		    rBind.Invalidate( SID_REHEARSE_TIMINGS );
//STRIP001 	        rBind.Update( SID_CLOSEDOC );
//STRIP001 	        rBind.Update( SID_PRESENTATION );
//STRIP001 	        rBind.Update( SID_REHEARSE_TIMINGS );
//STRIP001         }
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::CreatePageList( BOOL bAll, BOOL bStartWithActualPage, const String& rPresPage )
//STRIP001 {
//STRIP001 	const long nPageCount = pDoc->GetSdPageCount( PK_STANDARD );
//STRIP001 
//STRIP001 	if( nPageCount )
//STRIP001 	{
//STRIP001 		SdCustomShow*	pCustomShow;
//STRIP001 
//STRIP001 		if( !bStartWithActualPage && pDoc->GetCustomShowList() && pDoc->IsCustomShow() )
//STRIP001 			pCustomShow = (SdCustomShow*) pDoc->GetCustomShowList()->GetCurObject();
//STRIP001 		else
//STRIP001 			pCustomShow = NULL;
//STRIP001 
//STRIP001 		if( !pCustomShow || !pCustomShow->Count() )
//STRIP001 		{
//STRIP001 			USHORT nFirstPage = 0;
//STRIP001 
//STRIP001 			// normale Prsentation
//STRIP001 			if( !bAll )
//STRIP001 			{
//STRIP001 				String aFirstName( rPresPage );
//STRIP001 
//STRIP001 				if( aFirstName.Len() )
//STRIP001 				{
//STRIP001 					long nPage;
//STRIP001 					BOOL bTakeNextAvailable = FALSE;
//STRIP001 
//STRIP001 					for( nPage = 0, nFirstPage = 0xffff; ( nPage < nPageCount ) && ( 0xffff == nFirstPage ); nPage++ )
//STRIP001 					{
//STRIP001 						SdPage* pTestPage = pDoc->GetSdPage( (USHORT) nPage, PK_STANDARD );
//STRIP001 
//STRIP001 						if( pTestPage->GetName() == aFirstName )
//STRIP001 						{
//STRIP001 							if( pTestPage->IsExcluded() )
//STRIP001 								bTakeNextAvailable = TRUE;
//STRIP001 							else
//STRIP001 								nFirstPage = (USHORT) nPage;
//STRIP001 						}
//STRIP001 						else if( bTakeNextAvailable && !pTestPage->IsExcluded() )
//STRIP001 							nFirstPage = (USHORT) nPage;
//STRIP001 					}
//STRIP001 
//STRIP001 					// wenn nicht gefunden (z. B. bei "Seite3")
//STRIP001 					if( 0xffff == nFirstPage )
//STRIP001 						nFirstPage = 0;
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			for( USHORT i = 0; i < nPageCount; i++ )
//STRIP001 				if( !( pDoc->GetSdPage( i, PK_STANDARD ) )->IsExcluded() || ANIMATIONMODE_PREVIEW == eAnimationMode )
//STRIP001 					aAnimPageList.InsertPageNum( i );
//STRIP001 
//STRIP001 			aAnimPageList.SetStartPage( nFirstPage );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if( eAnimationMode != ANIMATIONMODE_SHOW && rPresPage.Len() )
//STRIP001 			{
//STRIP001 				long nPage;
//STRIP001 
//STRIP001 				for( nPage = 0; nPage < nPageCount; nPage++ )
//STRIP001 					if( rPresPage == pDoc->GetSdPage( (USHORT) nPage, PK_STANDARD )->GetName() )
//STRIP001 						break;
//STRIP001 
//STRIP001 				if( nPage < nPageCount )
//STRIP001 					aAnimPageList.InsertPageNum( (USHORT) nPage );
//STRIP001 			}
//STRIP001 
//STRIP001 			for( void* pCustomPage = pCustomShow->First(); pCustomPage; pCustomPage = pCustomShow->Next() )
//STRIP001 			{
//STRIP001 				const USHORT nSdPage = ( ( (SdPage*) pCustomPage )->GetPageNum() - 1 ) / 2;
//STRIP001 
//STRIP001 				if( !( pDoc->GetSdPage( nSdPage, PK_STANDARD ) )->IsExcluded() || ANIMATIONMODE_PREVIEW == eAnimationMode )
//STRIP001 					aAnimPageList.InsertPageNum( nSdPage );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::StopTextOrGraphicAnimation( SdrObject* pObject, BOOL bAll )
//STRIP001 {
//STRIP001 	// Grafikanimation waehrend des Effekts unterbinden
//STRIP001 	if ( OBJIS_GRAFANIM( pObject ) )
//STRIP001 	{
//STRIP001 		( (SdrGrafObj*) pObject )->StopAnimation( pShowWindow, (long) pObject );
//STRIP001 
//STRIP001 		if ( bAll )
//STRIP001 			( (SdrGrafObj*) pObject )->StopAnimation( pShowWindow );
//STRIP001 	}
//STRIP001 
//STRIP001 	// Textanimation waehrend des Effekts unterbinden
//STRIP001 	if ( OBJIS_TEXTANIM( pObject ) )
//STRIP001 	{
//STRIP001 		( (SdrTextObj*) pObject )->StopTextAnimation( pShowWindow, (long) pObject );
//STRIP001 
//STRIP001 		if ( bAll )
//STRIP001 			( (SdrTextObj*) pObject )->StopTextAnimation( pShowWindow );
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::ResortAnmList( List& rAnmList )
//STRIP001 {
//STRIP001 	const ULONG nCount = rAnmList.Count();
//STRIP001 
//STRIP001 	if ( nCount )
//STRIP001 	{
//STRIP001 		PSORT	pSort = new SORT[ nCount ];
//STRIP001 		ULONG	nOrderIndex = 0UL;
//STRIP001 		ULONG	nAppendIndex = LIST_APPEND - nCount;
//STRIP001 
//STRIP001 		for( SdrObject* pObj = (SdrObject*) rAnmList.First(); pObj; pObj = (SdrObject*) rAnmList.Next() )
//STRIP001 		{
//STRIP001 			const SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo( pObj );
//STRIP001 			PSORT					pSortTmp = &pSort[ nOrderIndex++ ];
//STRIP001 
//STRIP001 			pSortTmp->pObj = pObj;
//STRIP001 			pSortTmp->nOrder = ( pInfo->nPresOrder != LIST_APPEND ) ? pInfo->nPresOrder : nAppendIndex++;
//STRIP001 		}
//STRIP001 
//STRIP001 		// Liste loeschen, die Information steckt jetzt im Array
//STRIP001 		rAnmList.Clear();
//STRIP001 
//STRIP001 		// Array nach Ordnungsnummern sortieren
//STRIP001 		qsort( pSort, nCount, sizeof( SORT ), SortFunc );
//STRIP001 
//STRIP001 		// Animationliste neu aufbauen
//STRIP001 		for( ULONG i = 0UL; i < nCount; i++ )
//STRIP001 			rAnmList.Insert( pSort[ i ].pObj, LIST_APPEND );
//STRIP001 
//STRIP001 		delete[] pSort;
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|* Time Out Handler fuer Escape
|*
\************************************************************************/

//STRIP001 IMPL_LINK( FuSlideShow, EscapeHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	pTimer->Stop();
//STRIP001 	Terminate();
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::SetAnimationOwnerState( SdrView* pOwnerView, BOOL bShowIsOwner )
//STRIP001 {
//STRIP001 	SdrPageView* pPageView = pOwnerView->GetPageView( pActualPage );
//STRIP001 
//STRIP001 	if( pPageView )
//STRIP001 	{
//STRIP001 		SdrObjListIter	aMasterIter( *pActualPage->GetMasterPage( 0 ), IM_DEEPWITHGROUPS );
//STRIP001 		SdrObjListIter	aIter( *pActualPage, IM_DEEPWITHGROUPS );
//STRIP001 
//STRIP001 		for( SdrObject* pMasterO = aMasterIter.Next(); pMasterO; pMasterO = aMasterIter.Next() )
//STRIP001 		{
//STRIP001 			if( OBJIS_GRAFANIM( pMasterO ) )
//STRIP001 				( (SdrGrafObj*) pMasterO )->SetAnimationSupervisor( pShowWindow, !bShowIsOwner );
//STRIP001 
//STRIP001 			if( OBJIS_TEXTANIM( pMasterO ) )
//STRIP001 				( (SdrTextObj*) pMasterO )->SetTextAnimationSupervisor( pShowWindow, !bShowIsOwner );
//STRIP001 		}
//STRIP001 
//STRIP001 		for( SdrObject* pO = aIter.Next(); pO; pO = aIter.Next() )
//STRIP001 		{
//STRIP001 			if( OBJIS_GRAFANIM( pO ) )
//STRIP001 				( (SdrGrafObj*) pO )->SetAnimationSupervisor( pShowWindow, !bShowIsOwner );
//STRIP001 
//STRIP001 			if( OBJIS_TEXTANIM( pO ) )
//STRIP001 				( (SdrTextObj*) pO )->SetTextAnimationSupervisor( pShowWindow, !bShowIsOwner );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::UpdateVDevWithAnimations()
//STRIP001 {
//STRIP001 	SdrPageView* pPageView = pView->GetPageView( pActualPage );
//STRIP001 
//STRIP001 	if ( pPageView )
//STRIP001 	{
//STRIP001 		SdrObjListIter	aMasterIter( *pActualPage->GetMasterPage( 0 ), IM_DEEPWITHGROUPS );
//STRIP001 		SdrObjListIter	aIter( *pActualPage, IM_DEEPWITHGROUPS );
//STRIP001 
//STRIP001 		for( SdrObject* pMasterO = aMasterIter.Next(); pMasterO; pMasterO = aMasterIter.Next() )
//STRIP001 		{
//STRIP001 			if( OBJIS_GRAFANIM( pMasterO ) )
//STRIP001 			{
//STRIP001 				const Rectangle aRect( ( (SdrGrafObj*) pMasterO )->GetAnimationRect( pShowWindow ) );
//STRIP001 				pVDev->DrawOutDev( aRect.TopLeft(), aRect.GetSize(),
//STRIP001 								   aRect.TopLeft(), aRect.GetSize(), *pShowWindow );
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		for( SdrObject* pO = aIter.Next(); pO; pO = aIter.Next() )
//STRIP001 		{
//STRIP001 			if( OBJIS_GRAFANIM( pO ) )
//STRIP001 			{
//STRIP001 				const Rectangle aRect( ( (SdrGrafObj*) pO )->GetAnimationRect( pShowWindow ) );
//STRIP001 				pVDev->DrawOutDev( aRect.TopLeft(), aRect.GetSize(),
//STRIP001 								   aRect.TopLeft(), aRect.GetSize(), *pShowWindow );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::DrawOrStartAnimation( SdrObject* pObj, OutputDevice* pOut,
//STRIP001 										BOOL bStart, BOOL bTextObjs )
//STRIP001 {
//STRIP001 	if( bStart )
//STRIP001 	{
//STRIP001 		if( OBJIS_GRAFANIM( pObj ) )
//STRIP001 		{
//STRIP001 			const Rectangle	aRect( ( ( SdrGrafObj*) pObj )->GetAnimationRect( pOut ) );
//STRIP001 			( (SdrGrafObj*) pObj )->StartAnimation( pOut, aRect.TopLeft(), aRect.GetSize(), (long) pObj );
//STRIP001 		}
//STRIP001 
//STRIP001 		if( bTextObjs && OBJIS_TEXTANIM( pObj ) )
//STRIP001 			((SdrTextObj*)pObj)->StartTextAnimation( pShowWindow, Point(), (long) pObj );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		ExtOutputDevice aOut( pOut );
//STRIP001 		SdrPaintInfoRec aPaintInfoRec;
//STRIP001 		const ULONG		nOldDrawMode = pOut->GetDrawMode();
//STRIP001 		SdrObject*		pClone = pObj->Clone();
//STRIP001 
//STRIP001 		SetPaintModes( (SdrView*) pView, NULL, &aOut, &aPaintInfoRec );
//STRIP001 
//STRIP001 		if( OBJIS_GRAFANIM( pObj ) )
//STRIP001 			( (SdrGrafObj*) pClone )->SetGraphic( ( (SdrGrafObj*) pObj )->GetTransformedGraphic().GetBitmapEx() );
//STRIP001 
//STRIP001 		if( OBJIS_TEXTANIM( pObj ) )
//STRIP001 		{
//STRIP001 			SfxItemSet aTempAttr( pDoc->GetPool(), SDRATTR_TEXT_ANIKIND, SDRATTR_TEXT_ANIKIND );
//STRIP001 
//STRIP001 			aTempAttr.Set(pClone->GetItemSet());
//STRIP001 
//STRIP001 			aTempAttr.Put( SdrTextAniKindItem() );
//STRIP001 
//STRIP001 			pClone->SetItemSet(aTempAttr);
//STRIP001 		}
//STRIP001 
//STRIP001 		pOut->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001 		pClone->Paint( aOut, aPaintInfoRec );
//STRIP001 		pOut->SetDrawMode( nOldDrawMode );
//STRIP001 		delete pClone;
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void FuSlideShow::RepaintVDev( SdrPage* pRepaintPage, BOOL bOnlyMaster )
//STRIP001 {
//STRIP001 	const ULONG nOldDrawMode = pVDev->GetDrawMode();
//STRIP001 	FASTBOOL	bCached = FALSE;
//STRIP001 
//STRIP001 	pVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 	pVDev->Erase();
//STRIP001 	pVDev->SetDrawMode( nOldDrawMode );
//STRIP001 
//STRIP001 	if( pShowView->IsMasterPagePaintCaching() && ( nMasterPageCacheMode == SDR_MASTERPAGECACHE_FULL ) )
//STRIP001 	{
//STRIP001 		ExtOutputDevice	aOut( pVDev );
//STRIP001 		SdrPaintInfoRec	aInfoRec;
//STRIP001 		SdrPageView*	pPageView = pShowView->GetPageView( pRepaintPage );
//STRIP001 
//STRIP001 		if( pPageView )
//STRIP001 		{
//STRIP001 			aInfoRec.aPaintLayer = pRepaintPage->GetMasterPageVisibleLayers( 0 );
//STRIP001 			aInfoRec.aDirtyRect = Rectangle( aPageOrigin, aPageSize );
//STRIP001 			aInfoRec.pPV = pPageView;
//STRIP001 			aInfoRec.nPaintMode = SDRPAINTMODE_MASTERPAGE;
//STRIP001 			bCached = pPageView->DoCachedMasterPaint((SdPage*) pRepaintPage->GetMasterPage( 0 ),aOut,aInfoRec);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bOnlyMaster )
//STRIP001 	{
//STRIP001 		if( !bCached )
//STRIP001 			pMetaFile->Play( pVDev, MTF_START, FIRST_START );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if( bCached )
//STRIP001 			pMetaFile->Play( pVDev, FIRST_START, MTF_END );
//STRIP001 		else
//STRIP001 			pMetaFile->Play( pVDev, MTF_START, MTF_END );
//STRIP001 	}
//STRIP001 }


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 SdViewShell* FuSlideShow::GetDrawViewShellForShow() const
//STRIP001 {
//STRIP001 	SfxViewShell*	pShell = SfxViewShell::Current();
//STRIP001 	SdViewShell*	pViewSh = PTR_CAST( SdViewShell, pShell );
//STRIP001 
//STRIP001 	if ( !pViewSh && pDocSh )
//STRIP001 		pViewSh = pDocSh->GetViewShell();
//STRIP001 
//STRIP001 	return pViewSh;
//STRIP001 }

}
