/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_postdlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 05:00:17 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif
#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_USEROPTIONS_HXX
#include <svtools/useroptions.hxx>
#endif
#pragma hdrstop

#ifndef _UNOTOOLS_LOCALEDATAWRAPPER_HXX
#include <unotools/localedatawrapper.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <comphelper/processfactory.hxx>
#endif

#define _SVX_POSTDLG_CXX

#include "dialogs.hrc"
#include "postdlg.hrc"

#define ITEMID_AUTHOR	SID_ATTR_POSTIT_AUTHOR
#define ITEMID_DATE 	SID_ATTR_POSTIT_DATE
#define ITEMID_TEXT 	SID_ATTR_POSTIT_TEXT

#include "postattr.hxx"
#include "postdlg.hxx"
#include "dialmgr.hxx"

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif

#include "helpid.hrc"
namespace binfilter {

// static ----------------------------------------------------------------

//STRIP001 static USHORT pRanges[] =
//STRIP001 {
//STRIP001 	SID_ATTR_POSTIT_AUTHOR,
//STRIP001 	SID_ATTR_POSTIT_TEXT,
//STRIP001 	0
//STRIP001 };

// class SvxPostItDialog -------------------------------------------------

//STRIP001 SvxPostItDialog::SvxPostItDialog( Window* pParent,
//STRIP001 								  const SfxItemSet& rCoreSet,
//STRIP001 								  BOOL bPrevNext,
//STRIP001 								  BOOL bRedline ) :
//STRIP001 
//STRIP001 	SfxModalDialog( pParent, SVX_RES( RID_SVXDLG_POSTIT ) ),
//STRIP001 
//STRIP001 	aLastEditLabelFT( this, ResId( FT_LASTEDITLABEL ) ),
//STRIP001 	aLastEditFT 	( this, ResId( FT_LASTEDIT ) ),
//STRIP001 	aEditFT 		( this, ResId( FT_EDIT ) ),
//STRIP001 	aEditED 		( this, ResId( ED_EDIT ) ),
//STRIP001     aPostItFL       ( this, ResId( FL_POSTIT ) ),
//STRIP001 	aOKBtn			( this, ResId( BTN_POST_OK ) ),
//STRIP001 	aCancelBtn		( this, ResId( BTN_POST_CANCEL ) ),
//STRIP001 	aPrevBtn		( this, ResId( BTN_PREV ) ),
//STRIP001 	aNextBtn		( this, ResId( BTN_NEXT ) ),
//STRIP001     aAuthorFT       ( this, ResId( FT_AUTHOR) ),
//STRIP001     aAuthorBtn      ( this, ResId( BTN_AUTHOR ) ),
//STRIP001 	aHelpBtn		( this, ResId( BTN_POST_HELP ) ),
//STRIP001 
//STRIP001 	rSet		( rCoreSet ),
//STRIP001 	pOutSet 	( 0 )
//STRIP001 
//STRIP001 {
//STRIP001 	if (bRedline)	// HelpIDs fuer Redlining
//STRIP001 	{
//STRIP001 		SetHelpId(HID_REDLINING_DLG);
//STRIP001 		aEditED.SetHelpId(HID_REDLINING_EDIT);
//STRIP001 		aPrevBtn.SetHelpId(HID_REDLINING_PREV);
//STRIP001 		aNextBtn.SetHelpId(HID_REDLINING_NEXT);
//STRIP001 	}
//STRIP001 
//STRIP001 	aPrevBtn.SetClickHdl( LINK( this, SvxPostItDialog, PrevHdl ) );
//STRIP001 	aNextBtn.SetClickHdl( LINK( this, SvxPostItDialog, NextHdl ) );
//STRIP001 	aAuthorBtn.SetClickHdl( LINK( this, SvxPostItDialog, Stamp ) );
//STRIP001 	aOKBtn.SetClickHdl( LINK( this, SvxPostItDialog, OKHdl ) );
//STRIP001 
//STRIP001 	Font aFont( aEditED.GetFont() );
//STRIP001 	aFont.SetWeight( WEIGHT_LIGHT );
//STRIP001 	aEditED.SetFont( aFont );
//STRIP001 
//STRIP001 	BOOL bNew = TRUE;
//STRIP001 	const SfxPoolItem* pItem = 0;
//STRIP001 	USHORT nWhich			 = 0;
//STRIP001 
//STRIP001 	if ( !bPrevNext )
//STRIP001 	{
//STRIP001 		aPrevBtn.Hide();
//STRIP001 		aNextBtn.Hide();
//STRIP001 	}
//STRIP001 
//STRIP001 	nWhich = rSet.GetPool()->GetWhich( SID_ATTR_POSTIT_AUTHOR );
//STRIP001 	String aAuthorStr, aDateStr, aTextStr;
//STRIP001 
//STRIP001 	if ( rSet.GetItemState( nWhich, TRUE ) >= SFX_ITEM_AVAILABLE )
//STRIP001 	{
//STRIP001 		bNew = FALSE;
//STRIP001 		const SvxPostItAuthorItem& rAuthor =
//STRIP001 			(const SvxPostItAuthorItem&)rSet.Get( nWhich );
//STRIP001 		aAuthorStr = rAuthor.GetValue();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aAuthorStr = SvtUserOptions().GetID();
//STRIP001 
//STRIP001 	nWhich = rSet.GetPool()->GetWhich( SID_ATTR_POSTIT_DATE );
//STRIP001 
//STRIP001 	if ( rSet.GetItemState( nWhich, TRUE ) >= SFX_ITEM_AVAILABLE )
//STRIP001 	{
//STRIP001 		const SvxPostItDateItem& rDate =
//STRIP001 			(const SvxPostItDateItem&)rSet.Get( nWhich );
//STRIP001 		aDateStr = rDate.GetValue();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		LocaleDataWrapper aLocaleWrapper( ::legacy_binfilters::getLegacyProcessServiceFactory(), Application::GetSettings().GetLocale() );
//STRIP001 		aDateStr = aLocaleWrapper.getDate( Date() );
//STRIP001 	}
//STRIP001 
//STRIP001 	nWhich = rSet.GetPool()->GetWhich( SID_ATTR_POSTIT_TEXT );
//STRIP001 
//STRIP001 	if ( rSet.GetItemState( nWhich, TRUE ) >= SFX_ITEM_AVAILABLE )
//STRIP001 	{
//STRIP001 		const SvxPostItTextItem& rText =
//STRIP001 			(const SvxPostItTextItem&)rSet.Get( nWhich );
//STRIP001 		aTextStr = rText.GetValue();
//STRIP001 	}
//STRIP001 
//STRIP001 	ShowLastAuthor(aAuthorStr, aDateStr);
//STRIP001 	aEditED.SetText( aTextStr.ConvertLineEnd() );
//STRIP001 
//STRIP001 	if ( !bNew )
//STRIP001 		SetText( SVX_RESSTR( STR_NOTIZ_EDIT ) );
//STRIP001 	else
//STRIP001 		// neu anlegen
//STRIP001 		SetText( SVX_RESSTR( STR_NOTIZ_INSERT ) );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxPostItDialog::~SvxPostItDialog()
//STRIP001 {
//STRIP001 	delete pOutSet;
//STRIP001 	pOutSet = 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxPostItDialog::ShowLastAuthor(const String& rAuthor, const String& rDate)
//STRIP001 {
//STRIP001 	String sTxt( rAuthor );
//STRIP001 	sTxt.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ", " ) );
//STRIP001 	sTxt += rDate;
//STRIP001 	aLastEditFT.SetText( sTxt );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 USHORT* SvxPostItDialog::GetRanges()
//STRIP001 {
//STRIP001 	return pRanges;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxPostItDialog::EnableTravel(BOOL bNext, BOOL bPrev)
//STRIP001 {
//STRIP001 	aPrevBtn.Enable(bPrev);
//STRIP001 	aNextBtn.Enable(bNext);
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK_INLINE_START( SvxPostItDialog, PrevHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	aPrevHdlLink.Call( this );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SvxPostItDialog, PrevHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK_INLINE_START( SvxPostItDialog, NextHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	aNextHdlLink.Call( this );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SvxPostItDialog, NextHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( SvxPostItDialog, Stamp, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	Date aDate;
//STRIP001 	Time aTime;
//STRIP001 	String aTmp( SvtUserOptions().GetID() );
//STRIP001 	LocaleDataWrapper aLocaleWrapper( ::legacy_binfilters::getLegacyProcessServiceFactory(), Application::GetSettings().GetLocale() );
//STRIP001 	String aStr( aEditED.GetText() );
//STRIP001 	aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "\n---- " ) );
//STRIP001 
//STRIP001 	if ( aTmp.Len() > 0 )
//STRIP001 	{
//STRIP001 		aStr += aTmp;
//STRIP001 		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ", " ) );
//STRIP001 	}
//STRIP001 	aStr += aLocaleWrapper.getDate(aDate);
//STRIP001 	aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ", " ) );
//STRIP001 	aStr += aLocaleWrapper.getTime(aTime, FALSE, FALSE);
//STRIP001 	aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " ----\n" ) );
//STRIP001 
//STRIP001 
//STRIP001 	aEditED.SetText( aStr.ConvertLineEnd() );
//STRIP001 	xub_StrLen nLen = aStr.Len();
//STRIP001 	aEditED.GrabFocus();
//STRIP001 	aEditED.SetSelection( Selection( nLen, nLen ) );
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( SvxPostItDialog, OKHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	LocaleDataWrapper aLocaleWrapper( ::legacy_binfilters::getLegacyProcessServiceFactory(), Application::GetSettings().GetLocale() );
//STRIP001 	pOutSet = new SfxItemSet( rSet );
//STRIP001 	pOutSet->Put( SvxPostItAuthorItem( SvtUserOptions().GetID(),
//STRIP001 				  					   rSet.GetPool()->GetWhich( SID_ATTR_POSTIT_AUTHOR ) ) );
//STRIP001 	pOutSet->Put( SvxPostItDateItem( aLocaleWrapper.getDate( Date() ),
//STRIP001 									 rSet.GetPool()->GetWhich( SID_ATTR_POSTIT_DATE ) ) );
//STRIP001 	pOutSet->Put( SvxPostItTextItem( aEditED.GetText(),
//STRIP001 									 rSet.GetPool()->GetWhich( SID_ATTR_POSTIT_TEXT ) ) );
//STRIP001 	EndDialog( RET_OK );
//STRIP001 	return 0;
//STRIP001 }

}
