/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_tabline.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 05:06:48 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#include <svtools/pathoptions.hxx>
#endif
#ifndef _SFXAPP_HXX
#include <bf_sfx2/app.hxx>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <bf_sfx2/objsh.hxx>
#endif
#pragma hdrstop

#define _SVX_TABLINE_CXX
#include "dialogs.hrc"
#include "tabline.hrc"
#include "dlgname.hrc"

#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#define ITEMID_DASH_LIST		SID_DASH_LIST
#define ITEMID_LINEEND_LIST		SID_LINEEND_LIST

#include "tabline.hxx"
#include "dlgname.hxx"
#include "dialmgr.hxx"
#include "svdmodel.hxx"
#include "xtable.hxx"
#include "drawitem.hxx"
namespace binfilter {

//STRIP001 #define DLGWIN this->GetParent()->GetParent()

//STRIP001 #define BITMAP_WIDTH   32
//STRIP001 #define BITMAP_HEIGHT  12
//STRIP001 #define XOUT_WIDTH    150

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

//STRIP001 SvxLineTabDialog::SvxLineTabDialog
//STRIP001 (
//STRIP001 	Window* pParent,
//STRIP001 	const SfxItemSet* pAttr,
//STRIP001 	SdrModel* pModel,
//STRIP001 	const SdrObject* pSdrObj,
//STRIP001 	BOOL bHasObj
//STRIP001 ) :
//STRIP001 
//STRIP001 	SfxTabDialog	( pParent, SVX_RES( RID_SVXDLG_LINE ), pAttr ),
//STRIP001 	pDrawModel		( pModel ),
//STRIP001 	pObj			( pSdrObj ),
//STRIP001 	bObjSelected	( bHasObj ),
//STRIP001 	pColorTab		( pModel->GetColorTable() ),
//STRIP001 	pDashList       ( pModel->GetDashList() ),
//STRIP001 	pLineEndList    ( pModel->GetLineEndList() ),
//STRIP001 	pNewDashList    ( pModel->GetDashList() ),
//STRIP001 	pNewLineEndList ( pModel->GetLineEndList() ),
//STRIP001 	rOutAttrs		( *pAttr )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	AddTabPage( RID_SVXPAGE_LINE, SvxLineTabPage::Create, 0);
//STRIP001 	AddTabPage( RID_SVXPAGE_LINE_DEF, SvxLineDefTabPage::Create, 0);
//STRIP001 	AddTabPage( RID_SVXPAGE_LINEEND_DEF, SvxLineEndDefTabPage::Create, 0);
//STRIP001 
//STRIP001 	nLineEndListState = CT_NONE;
//STRIP001 	nDashListState = CT_NONE;
//STRIP001 
//STRIP001 	nDlgType = 0;
//STRIP001 	nPageType = 0; // wird hier in erster Linie benutzt, um mit FillItemSet
//STRIP001 				   // die richtigen Attribute zu erhalten ( noch Fragen? )
//STRIP001 	nPosDashLb = 0;
//STRIP001 	nPosLineEndLb = 0;
//STRIP001 
//STRIP001 	SetCurPageId( RID_SVXPAGE_LINE );
//STRIP001 
//STRIP001 	CancelButton& rBtnCancel = GetCancelButton();
//STRIP001 	rBtnCancel.SetClickHdl( LINK( this, SvxLineTabDialog, CancelHdl ) );
//STRIP001 //! rBtnCancel.SetText( SVX_RESSTR( RID_SVXSTR_CLOSE ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxLineTabDialog::~SvxLineTabDialog()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxLineTabDialog::SavePalettes()
//STRIP001 {
//STRIP001 	if( pNewDashList != pDrawModel->GetDashList() )
//STRIP001 	{
//STRIP001 		delete pDrawModel->GetDashList();
//STRIP001 		pDrawModel->SetDashList( pNewDashList );
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxDashListItem( pNewDashList ) );
//STRIP001 		pDashList = pDrawModel->GetDashList();
//STRIP001 	}
//STRIP001 	if( pNewLineEndList != pDrawModel->GetLineEndList() )
//STRIP001 	{
//STRIP001 		delete pDrawModel->GetLineEndList();
//STRIP001 		pDrawModel->SetLineEndList( pNewLineEndList );
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxLineEndListItem( pNewLineEndList ) );
//STRIP001 		pLineEndList = pDrawModel->GetLineEndList();
//STRIP001 	}
//STRIP001 
//STRIP001 	// Speichern der Tabellen, wenn sie geaendert wurden.
//STRIP001 
//STRIP001 	const String aPath( SvtPathOptions().GetPalettePath() );
//STRIP001 
//STRIP001 	if( nDashListState & CT_MODIFIED )
//STRIP001 	{
//STRIP001 		pDashList->SetPath( aPath );
//STRIP001 		pDashList->Save();
//STRIP001 
//STRIP001 		// ToolBoxControls werden benachrichtigt:
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxDashListItem( pDashList ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nLineEndListState & CT_MODIFIED )
//STRIP001 	{
//STRIP001 		pLineEndList->SetPath( aPath );
//STRIP001 		pLineEndList->Save();
//STRIP001 
//STRIP001 		// ToolBoxControls werden benachrichtigt:
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxLineEndListItem( pLineEndList ) );
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 short SvxLineTabDialog::Ok()
//STRIP001 {
//STRIP001 	SavePalettes();
//STRIP001 
//STRIP001 	// Es wird RET_OK zurueckgeliefert, wenn wenigstens eine
//STRIP001 	// TabPage in FillItemSet() TRUE zurueckliefert. Dieses
//STRIP001 	// geschieht z.Z. standardmaessig.
//STRIP001 	return( SfxTabDialog::Ok() );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK_INLINE_START( SvxLineTabDialog, CancelHdl, void *, p )
//STRIP001 {
//STRIP001 	SavePalettes();
//STRIP001 
//STRIP001 	EndDialog( RET_CANCEL );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SvxLineTabDialog, CancelHdl, void *, p )

// -----------------------------------------------------------------------

//STRIP001 void SvxLineTabDialog::PageCreated( USHORT nId, SfxTabPage &rPage )
//STRIP001 {
//STRIP001 	switch( nId )
//STRIP001 	{
//STRIP001 		case RID_SVXPAGE_LINE:
//STRIP001 			( (SvxLineTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetDashList( pDashList );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetLineEndList( pLineEndList );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetPosDashLb( &nPosDashLb );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetPosLineEndLb( &nPosLineEndLb );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetDashChgd( &nDashListState );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetLineEndChgd( &nLineEndListState );
//STRIP001 			( (SvxLineTabPage&) rPage ).SetObjSelected( bObjSelected );
//STRIP001 			( (SvxLineTabPage&) rPage ).Construct();
//STRIP001 			// ActivatePage() wird das erste mal nicht gerufen
//STRIP001 			( (SvxLineTabPage&) rPage ).ActivatePage( rOutAttrs );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_LINE_DEF:
//STRIP001 			( (SvxLineDefTabPage&) rPage ).SetDashList( pDashList );
//STRIP001 			( (SvxLineDefTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxLineDefTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxLineDefTabPage&) rPage ).SetPosDashLb( &nPosDashLb );
//STRIP001 			( (SvxLineDefTabPage&) rPage ).SetDashChgd( &nDashListState );
//STRIP001 			( (SvxLineDefTabPage&) rPage ).SetObjSelected( bObjSelected );
//STRIP001 			( (SvxLineDefTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_LINEEND_DEF:
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetLineEndList( pLineEndList );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetPolyObj( pObj );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetPosLineEndLb( &nPosLineEndLb );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetLineEndChgd( &nLineEndListState );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).SetObjSelected( bObjSelected );
//STRIP001 			( (SvxLineEndDefTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }


}
