/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: gallery1.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 05:52:42 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_GALLERY1_HXX_
#define _SVX_GALLERY1_HXX_

// auto strip #include <tools/string.hxx>
// auto strip #include <tools/list.hxx>
// auto strip #include <tools/urlobj.hxx>
// auto strip #include <svtools/brdcst.hxx>
#include "gallery.hrc"
class SvStream;
class SfxListener;
namespace binfilter {

// ---------------------
// - GalleryThemeEntry -
// ---------------------


//STRIP001 class GalleryThemeEntry
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	String					aName;
//STRIP001 	INetURLObject			aThmURL;
//STRIP001 	INetURLObject			aSdgURL;
//STRIP001 	INetURLObject			aSdvURL;
//STRIP001 	UINT32					nFileNumber;
//STRIP001 	UINT32					nId;
//STRIP001 	BOOL					bReadOnly;
//STRIP001 	BOOL					bImported;
//STRIP001 	BOOL					bModified;
//STRIP001 	BOOL					bThemeNameFromResource;
//STRIP001 							
//STRIP001 							GalleryThemeEntry();
//STRIP001 	INetURLObject			ImplGetURLIgnoreCase( const INetURLObject& rURL ) const;
//STRIP001 							
//STRIP001 public:						
//STRIP001 							
//STRIP001 							GalleryThemeEntry( const INetURLObject& rBaseURL, const String& rName,
//STRIP001 											   UINT32 nFileNumber, BOOL bReadOnly, BOOL bImported,
//STRIP001 											   BOOL bNewFile, UINT32 nId, BOOL bThemeNameFromResource );
//STRIP001 							~GalleryThemeEntry() {};
//STRIP001 							
//STRIP001 	const String&			GetThemeName() const { return aName; }
//STRIP001 	UINT32					GetFileNumber() const { return nFileNumber; }
//STRIP001 
//STRIP001 	const INetURLObject&	GetThmURL() const { return aThmURL; }
//STRIP001 	const INetURLObject&	GetSdgURL() const { return aSdgURL; }
//STRIP001 	const INetURLObject&	GetSdvURL() const { return aSdvURL; }
//STRIP001 
//STRIP001 	BOOL					IsImported() const { return bImported; }
//STRIP001 	BOOL					IsReadOnly() const { return bReadOnly; }
//STRIP001 	BOOL					IsDefault() const { return( ( nId > 0 ) && ( nId != ( RID_GALLERYSTR_THEME_MYTHEME - RID_GALLERYSTR_THEME_START ) ) ); }
//STRIP001 							
//STRIP001 	BOOL					IsHidden() const { return aName.Search( String( RTL_CONSTASCII_USTRINGPARAM( "private://gallery/hidden/" ) ) ) == 0; }
//STRIP001 							
//STRIP001 	BOOL					IsModified() const { return bModified; }
//STRIP001 	void					SetModified( BOOL bSet ) { bModified = ( bSet && !IsImported() && !IsReadOnly() ); }
//STRIP001 							
//STRIP001 	void					SetName( const String& rNewName );
//STRIP001 	BOOL					IsNameFromResource() const { return bThemeNameFromResource; }
//STRIP001 							
//STRIP001 	UINT32					GetId() const { return nId; }
//STRIP001 	void					SetId( UINT32 nNewId, BOOL bResetThemeName );
//STRIP001 };

//STRIP001 DECLARE_LIST( GalleryThemeList, GalleryThemeEntry* )//STRIP008 DECLARE_LIST( GalleryThemeList, GalleryThemeEntry* );

// ---------------------------
// - GalleryImportThemeEntry -
// ---------------------------

//STRIP001 struct GalleryImportThemeEntry
//STRIP001 {
//STRIP001 	String			aThemeName;
//STRIP001 	String			aUIName;
//STRIP001 	INetURLObject	aURL;
//STRIP001 	String			aImportName;
//STRIP001 };
//STRIP001 DECLARE_LIST( GalleryImportThemeList, GalleryImportThemeEntry* ) //STRIP008 DECLARE_LIST( GalleryImportThemeList, GalleryImportThemeEntry* );

// -----------------------------------------------------------------------------

//STRIP001 SvStream& operator<<( SvStream& rOut, const GalleryImportThemeEntry& rEntry );
//STRIP001 SvStream& operator>>( SvStream& rIn, GalleryImportThemeEntry& rEntry );

// -----------
// - Gallery -
// -----------

class GalleryTheme;

//STRIP001 class Gallery : public SfxBroadcaster
//STRIP001 {
//STRIP001 	friend class GalleryCacheEntry;
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	static List					aGalleryCache;
//STRIP001 
//STRIP001 	GalleryThemeList			aThemeList;
//STRIP001 	GalleryImportThemeList		aImportList;
//STRIP001 	List						aThemeCache;
//STRIP001 	INetURLObject				aRelURL;
//STRIP001 	INetURLObject				aUserURL;
//STRIP001 	rtl_TextEncoding			nReadTextEncoding;
//STRIP001 	ULONG						nLastFileNumber;
//STRIP001 	BOOL						bMultiPath;
//STRIP001 								
//STRIP001 	void						ImplLoad( const String& rMultiPath );
//STRIP001 	void						ImplLoadSubDirs( const INetURLObject& rBaseURL, sal_Bool& rbIsReadOnly );
//STRIP001 	void						ImplLoadImports();
//STRIP001 	void 						ImplWriteImportList();
//STRIP001 	
//STRIP001 	GalleryThemeEntry*			ImplGetThemeEntry( const String& rThemeName );
//STRIP001 	GalleryThemeEntry* 			ImplGetThemeEntry( ULONG nThemeId );
//STRIP001 	GalleryImportThemeEntry*	ImplGetImportThemeEntry( const String& rImportName );
//STRIP001 
//STRIP001 	GalleryTheme*				ImplGetCachedTheme( const GalleryThemeEntry* pThemeEntry );
//STRIP001 	void						ImplDeleteCachedTheme( GalleryTheme* pTheme );
//STRIP001 
//STRIP001 								Gallery( const String& rMultiPath );
//STRIP001 								~Gallery();
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	static Gallery*				AcquireGallery( const String& rMultiPath );
//STRIP001 	static void					ReleaseGallery( Gallery* pGallery );
//STRIP001 								
//STRIP001 	const ULONG					GetThemeCount() const { return aThemeList.Count(); }
//STRIP001 	const GalleryThemeEntry*	GetThemeInfo( ULONG nPos ) { return aThemeList.GetObject( nPos ); }
//STRIP001 	const GalleryThemeEntry*	GetThemeInfo( const String& rThemeName ) { return ImplGetThemeEntry( rThemeName ); }
//STRIP001 	
//STRIP001 	BOOL						HasTheme( const String& rThemeName );
//STRIP001 	String						GetThemeName( ULONG nThemeId ) const;
//STRIP001 
//STRIP001 	BOOL						CreateTheme( const String& rThemeName );
//STRIP001 	BOOL						CreateImportTheme( const INetURLObject& rURL, const String& rFileName );
//STRIP001 	BOOL						RenameTheme( const String& rOldName, const String& rNewName );
//STRIP001 	BOOL						RemoveTheme( const String& rThemeName );
//STRIP001 
//STRIP001 	GalleryTheme*				AcquireTheme( const String& rThemeName, SfxListener& rListener );
//STRIP001 	void						ReleaseTheme( GalleryTheme*	pTheme, SfxListener& rListener );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	INetURLObject				GetImportURL( const String& rThemeName );
//STRIP001 	
//STRIP001 	const INetURLObject&		GetUserURL() const { return aUserURL; }
//STRIP001 	const INetURLObject&		GetRelativeURL() const { return aRelURL; }
//STRIP001 	
//STRIP001 	BOOL						IsMultiPath() const { return bMultiPath; }
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_GALLERY1_HXX_
