/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: msvbasic.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 06:25:12 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil -*- */

#ifndef _MSVBASIC_HXX
#define _MSVBASIC_HXX

#ifdef _SOLAR_H
#include <tools/solar.h>
#endif
// auto strip #ifndef _TOOLS_DEBUG_HXX
// auto strip #include <tools/debug.hxx>
// auto strip #endif
// auto strip #ifndef _SVSTOR_HXX //autogen
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
// auto strip #ifndef _DYNARY_HXX
// auto strip #include <tools/dynary.hxx>
// auto strip #endif
namespace binfilter {


/* class VBA:
 * The VBA class provides a set of methods to handle Visual Basic For
 * Applications streams, the constructor is given the root ole2 stream
 * of the document, Open reads the VBA project file and figures out
 * the number of VBA streams, and the offset of the data within them.
 * Decompress decompresses a particular numbered stream, NoStreams returns
 * this number, and StreamName can give you the streams name. Decompress
 * will return a string with the decompressed data. The optional extra
 * argument will be set if not NULL to 1 in the case of a string overflow,
 * if I can figure out how to do that.
 *
 * Otherwise it is possible to inherit from VBA and implement a Output
 * member which gets called with each 4096 output sized block.
 *
 * cmc
 * */

//STRIP001 DECLARE_DYNARRAY(StringArray,String *)//STRIP008 ;
//STRIP001 
//STRIP001 class VBA_Impl
//STRIP001 {
//STRIP001 public:
//STRIP001     VBA_Impl(SvStorage &rIn, bool bCmmntd = true)
//STRIP001         : xStor(&rIn), pOffsets(0), nOffsets(0), bCommented(bCmmntd),
//STRIP001         aVBAStrings(0), nLines(0), sComment(String::CreateFromAscii(
//STRIP001             RTL_CONSTASCII_STRINGPARAM("Rem "))), 
//STRIP001         meCharSet(RTL_TEXTENCODING_MS_1252), mbMac(false)
//STRIP001         {}
//STRIP001     ~VBA_Impl() 
//STRIP001     {
//STRIP001         if (nOffsets) 
//STRIP001             delete [] pOffsets;
//STRIP001         for(ULONG i=0;i<aVBAStrings.GetSize();i++)
//STRIP001             delete aVBAStrings.Get(i);
//STRIP001     }
//STRIP001     //0 for failure, 1 for success
//STRIP001     bool Open( const String &rToplevel, const String &rSublevel);
//STRIP001     const StringArray & Decompress(sal_uInt16 nIndex, int *pOverflow=0);
//STRIP001     sal_uInt16 GetNoStreams() const { return nOffsets; }
//STRIP001     const String &GetStreamName(sal_uInt16 nIndex) const
//STRIP001     {
//STRIP001         DBG_ASSERT( nIndex < nOffsets, "Index out of range" );
//STRIP001         return pOffsets[ nIndex ].sName;
//STRIP001     }
//STRIP001     virtual void Output(int len, const sal_uInt8 *data);
//STRIP001 private:
//STRIP001     struct VBAOffset_Impl
//STRIP001     {
//STRIP001         String sName;
//STRIP001         sal_uInt32 nOffset;
//STRIP001     };
//STRIP001 
//STRIP001     SvStorageRef xVBA;
//STRIP001     StringArray aVBAStrings;
//STRIP001     String sComment;
//STRIP001     SvStorageRef xStor;
//STRIP001     VBAOffset_Impl *pOffsets;
//STRIP001     sal_uInt16 nOffsets;
//STRIP001     enum Limits {nWINDOWLEN = 4096};
//STRIP001     sal_uInt8 aHistory[nWINDOWLEN];
//STRIP001     rtl_TextEncoding meCharSet;
//STRIP001     bool bCommented;
//STRIP001     bool mbMac;
//STRIP001     int nLines;
//STRIP001 
//STRIP001     //0 for failure, anything else for success
//STRIP001     int ReadVBAProject(const SvStorageRef &rxVBAStorage);
//STRIP001     int DecompressVBA(int index, SvStorageStreamRef &rxVBAStream);
//STRIP001     sal_uInt8 ReadPString(SvStorageStreamRef &xVBAProject, bool bIsUnicode);
//STRIP001     bool SkipTrickyMac(SvStorageStreamRef &xVBAProject);
//STRIP001 };

}//end of namespace binfilter
#endif

/* vi:set tabstop=4 shiftwidth=4 expandtab: */
