/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: frminf.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 09:29:49 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _FRMINF_HXX
#define _FRMINF_HXX

// auto strip #include "swtypes.hxx"
namespace binfilter {

class SwTxtFrm; 	// SwTxtFrmInfo
class SwPaM;		// SwTxtFrmInfo
class SwTxtCursor;	// SwTxtFrmInfo


/*************************************************************************
 *						class SwTxtFrmInfo
 *************************************************************************/

class SwTxtFrmInfo
{
	const SwTxtFrm *pFrm;

	// Wo beginnt der Text (ohne whitespaces)? (Dokument global !!)
//STRIP001 	SwTwips GetLineStart( const SwTxtCursor &rLine ) const;

public:
	inline SwTxtFrmInfo( const SwTxtFrm *pFrm ) : pFrm(pFrm) { }

	// Passt der Absatz in eine Zeile?
//STRIP001 	BOOL IsOneLine() const;

	// Ist die Zeile zu X% gefuellt?
//STRIP001 	BOOL IsFilled( const BYTE nPercent ) const;

	// Wo beginnt der Text (ohne whitespaces)? (rel. im Frame !!)
//STRIP001 	SwTwips GetLineStart() const;

	//returne die mittel Position des n. Charakters
//STRIP001 	SwTwips GetCharPos( xub_StrLen nChar, BOOL bCenter = TRUE ) const;

	// Sammelt die whitespaces am Zeilenbeginn und -ende im Pam
//STRIP001 	void GetSpaces( SwPaM &rPam, BOOL bWithLineBreak ) const;

	// Ist an der ersten Textposition ein Bullet/Symbol etc?
//STRIP001 	BOOL IsBullet( xub_StrLen nTxtPos ) const;

	// Ermittelt Erstzeileneinzug
//STRIP001 	SwTwips GetFirstIndent() const;

	// setze und erfrage den Frame;
	const SwTxtFrm* GetFrm() const { return pFrm; }
	SwTxtFrmInfo& SetFrm( const SwTxtFrm* pNew )
		{ pFrm = pNew; return *this; }

	// liegt eine Gegenueberstellung vor? (returnt Pos im Frame)
//STRIP001 	USHORT GetBigIndent( xub_StrLen& rFndPos,
//STRIP001 						const SwTxtFrm *pNextFrm = 0 ) const;
};



} //namespace binfilter
#endif

