/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sw_wizmmdlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 07:21:59 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/



#pragma hdrstop


#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif


#include "swtypes.hxx"
#include "wizmulti.hxx"
#include "wizard.hrc"
#include "wizmmdlg.hxx"
#include "numfmtlb.hxx"
namespace binfilter {


WizardMemoDialog::WizardMemoDialog(Window* pParent)
	: SwWizardDialog(pParent,SW_RES(DLG_WIZARD_MM),5)
{
	p1_Text_Stil  =new FixedText   (this,SW_RES(DLG_MM1_Text_Stil  ));
	p1_RBtn_Stil1 =new RadioButton (this,SW_RES(DLG_MM1_RBtn_Stil1 ));
	p1_RBtn_Stil2 =new RadioButton (this,SW_RES(DLG_MM1_RBtn_Stil2 ));
	p1_RBtn_Stil3 =new RadioButton (this,SW_RES(DLG_MM1_RBtn_Stil3 ));
	p1_Text_Titel =new FixedText   (this,SW_RES(DLG_MM1_Text_Titel ));
	p1_RBtn_TitTxt=new RadioButton (this,SW_RES(DLG_MM1_RBtn_TitTxt));
	p1_RBtn_TitGrf=new RadioButton (this,SW_RES(DLG_MM1_RBtn_TitGrf));
	p1_CBox_TitTxt=new ComboBox    (this,SW_RES(DLG_MM1_CBox_TitTxt));
	p1_PBtn_TitGrf=new PushButton  (this,SW_RES(DLG_MM1_PBtn_TitGrf));
	p1_Text_TitGrf=new FixedText   (this,SW_RES(DLG_MM1_Text_TitGrf));

	p2_Text_Welche=new FixedText   (this,SW_RES(DLG_MM2_Text_Welche));
	p2_CBox_Datum =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Datum ));
    p2_List_Datum =new NumFormatListBox (this,SW_RES(DLG_MM2_List_Datum ), NUMBERFORMAT_DATE, ULONG_MAX, FALSE);
	p2_CBox_Betref=new CheckBox    (this,SW_RES(DLG_MM2_CBox_Betref));
	p2_Edit_Betref=new Edit        (this,SW_RES(DLG_MM2_Edit_Betref));
	p2_CBox_MemoAn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_MemoAn));
	p2_CBox_KopiAn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_KopiAn));
	p2_CBox_MemoVn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_MemoVn));
	p2_CBox_Elem1 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem1 ));
	p2_Edit_Elem1 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem1 ));
	p2_CBox_Elem2 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem2 ));
	p2_Edit_Elem2 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem2 ));
	p2_CBox_Elem3 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem3 ));
	p2_Edit_Elem3 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem3 ));
	p2_CBox_Elem4 =new CheckBox    (this,SW_RES(DLG_MM2_CBox_Elem4 ));
	p2_Edit_Elem4 =new Edit        (this,SW_RES(DLG_MM2_Edit_Elem4 ));
	//p2_CBox_TrenLn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_TrenLn));
	//p2_CBox_Anlagn=new CheckBox    (this,SW_RES(DLG_MM2_CBox_Anlagn));

	p3_Text_KWelch=new FixedText   (this,SW_RES(DLG_MM3_Text_KWelch));
	p3_CBox_KDatum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KDatum));
	p3_CBox_KThema=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KThema));
	p3_CBox_KPgNum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KPgNum));
	p3_CBox_KTrnLn=new CheckBox    (this,SW_RES(DLG_MM3_CBox_KTrnLn));
	p3_Text_FWelch=new FixedText   (this,SW_RES(DLG_MM3_Text_FWelch));
	p3_CBox_FDatum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FDatum));
	p3_CBox_FVertr=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FVertr));
	p3_Edit_FVertr=new Edit        (this,SW_RES(DLG_MM3_Edit_FVertr));
	p3_CBox_FPgNum=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FPgNum));
	p3_CBox_FTrnLn=new CheckBox    (this,SW_RES(DLG_MM3_CBox_FTrnLn));

	p5_BMap_Fahne =new FixedBitmap (this,SW_RES(DLG_MM5_BMap_Fahne ));
	p5_Text_Final =new FixedText   (this,SW_RES(DLG_MM5_Text_Final ));

	FreeResource();
}

WizardMemoDialog::~WizardMemoDialog()
{
	delete p1_Text_Stil  ;
	delete p1_RBtn_Stil1 ;
	delete p1_RBtn_Stil2 ;
	delete p1_RBtn_Stil3 ;
	delete p1_Text_Titel ;
	delete p1_RBtn_TitTxt;
	delete p1_RBtn_TitGrf;
	delete p1_CBox_TitTxt;
	delete p1_PBtn_TitGrf;
	delete p1_Text_TitGrf;

	delete p2_Text_Welche;
	delete p2_CBox_Datum ;
	delete p2_List_Datum ;
	delete p2_CBox_Betref;
	delete p2_Edit_Betref;
	delete p2_CBox_MemoAn;
	delete p2_CBox_KopiAn;
	delete p2_CBox_MemoVn;
	delete p2_CBox_Elem1 ;
	delete p2_Edit_Elem1 ;
	delete p2_CBox_Elem2 ;
	delete p2_Edit_Elem2 ;
	delete p2_CBox_Elem3 ;
	delete p2_Edit_Elem3 ;
	delete p2_CBox_Elem4 ;
	delete p2_Edit_Elem4 ;
	//delete p2_CBox_TrenLn;
	//delete p2_CBox_Anlagn;

	delete p3_Text_KWelch;
	delete p3_CBox_KDatum;
	delete p3_CBox_KThema;
	delete p3_CBox_KPgNum;
	delete p3_CBox_KTrnLn;
	delete p3_Text_FWelch;
	delete p3_CBox_FDatum;
	delete p3_CBox_FVertr;
	delete p3_Edit_FVertr;
	delete p3_CBox_FPgNum;
	delete p3_CBox_FTrnLn;

	delete p5_BMap_Fahne ;
	delete p5_Text_Final ;
}


}
