/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: numfmt.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:57:34 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_NUMFMT_HXX
#define _SVX_NUMFMT_HXX

//------------------------------------------------------------------------

#ifndef _WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif

#ifndef _COLOR_HXX //autogen
#include <tools/color.hxx>
#endif

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SVX_LANGBOX_HXX //autogen
#include <bf_svx/langbox.hxx>
#endif

#ifndef SVX_FONTLB_HXX //autogen
#include <bf_svx/fontlb.hxx>
#endif
namespace binfilter {

//STRIP001 #define SVX_NUMVAL_STANDARD		-1234.12345678901234
//STRIP001 #define SVX_NUMVAL_CURRENCY		-1234
//STRIP001 #define SVX_NUMVAL_PERCENT		-0.1295
//STRIP001 #define SVX_NUMVAL_TIME 		36525.5678935185
//STRIP001 #define SVX_NUMVAL_DATE 		36525.5678935185
//STRIP001 #define SVX_NUMVAL_BOOLEAN 		1

//------------------------------------------------------------------------

//STRIP001 class SvxNumberFormatShell;
//STRIP001 class SvxNumberInfoItem;

//------------------------------------------------------------------------

//STRIP001 class SvxNumberPreviewImpl : public Window
//STRIP001 {
//STRIP001 private:
//STRIP001 	String			aPrevStr;
//STRIP001 	Color			aPrevCol;
//STRIP001 
//STRIP001 	void			InitSettings( BOOL bForeground, BOOL bBackground );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	Paint( const Rectangle& rRect );
//STRIP001 	virtual void	StateChanged( StateChangedType nStateChange );
//STRIP001 	virtual void	DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxNumberPreviewImpl( Window* pParent, const ResId& rResId );
//STRIP001 	~SvxNumberPreviewImpl();
//STRIP001 
//STRIP001     void            NotifyChange( const String& rPrevStr, const Color* pColor = NULL );
//STRIP001 };

// -----------------------------------------------------------------------

//STRIP001 class SvxNumberFormatTabPage : public SfxTabPage

/*	{k:\svx\prototyp\dialog\numfmt.bmp}

	[Beschreibung]
	Mit dieser TabPage koennen Zahlenformate eingestellt und benutzerdefinierte
	Formate verwaltet werden.

	[Items]
	<SfxUInt32Item>:		<SID_ATTR_NUMBERFORMAT_VALUE>
	<SvxNumberInfoItem>:	<SID_ATTR_NUMBERFORMAT_INFO>
*/

//STRIP001 {
//STRIP001 public:
//STRIP001 	~SvxNumberFormatTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*		Create( Window* pParent,
//STRIP001 									const SfxItemSet& rAttrSet );
//STRIP001 	static USHORT*			GetRanges();
//STRIP001 
//STRIP001 	virtual	BOOL 			FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 			Reset( const SfxItemSet& rSet );
//STRIP001 	virtual int 			DeactivatePage	( SfxItemSet* pSet = NULL );
//STRIP001 
//STRIP001 	void					SetInfoItem( const SvxNumberInfoItem& rItem );
//STRIP001 	void					SetNumberFormatList( const SvxNumberInfoItem& rItem )
//STRIP001 								{ SetInfoItem( rItem ); }
//STRIP001 
//STRIP001 	void					SetOkHdl( const Link& rOkHandler );
//STRIP001 	void					HideLanguage(BOOL nFlag=TRUE);
//STRIP001 	virtual long			PreNotify( NotifyEvent& rNEvt );
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxNumberFormatTabPage( Window*	pParent,
//STRIP001 							const SfxItemSet& rCoreAttrs );
//STRIP001 	FixedText				aFtCategory;
//STRIP001 	ListBox					aLbCategory;
//STRIP001 	FixedText				aFtFormat;
//STRIP001 	ListBox					aLbCurrency;
//STRIP001 	SvxFontListBox			aLbFormat;
//STRIP001 	FixedText				aFtLanguage;
//STRIP001 	SvxLanguageBox			aLbLanguage;
//STRIP001     CheckBox                aCbSourceFormat;
//STRIP001 
//STRIP001 	FixedText				aFtDecimals;
//STRIP001 	NumericField			aEdDecimals;
//STRIP001 	FixedText				aFtLeadZeroes;
//STRIP001 	NumericField			aEdLeadZeroes;
//STRIP001 	CheckBox				aBtnNegRed;
//STRIP001 	CheckBox				aBtnThousand;
//STRIP001     FixedLine               aFlOptions;
//STRIP001 
//STRIP001 	FixedText				aFtEdFormat;
//STRIP001 	Edit					aEdFormat;
//STRIP001 	ImageButton				aIbAdd;
//STRIP001 	ImageButton				aIbInfo;
//STRIP001 	ImageButton				aIbRemove;
//STRIP001 	ImageList				aIconListDepricated;
//STRIP001 
//STRIP001 	FixedText				aFtComment;
//STRIP001 	Edit					aEdComment;
//STRIP001 	Timer					aResetWinTimer;
//STRIP001 
//STRIP001 	SvxNumberPreviewImpl	aWndPreview;
//STRIP001 
//STRIP001 	SvxNumberInfoItem*		pNumItem;
//STRIP001 	SvxNumberFormatShell* 	pNumFmtShell;
//STRIP001 	ULONG					nInitFormat;
//STRIP001 	Link					fnOkHdl;
//STRIP001 
//STRIP001 	BOOL					bNumItemFlag; //Fuer Handling mit DocShell
//STRIP001 	BOOL					bOneAreaFlag;
//STRIP001 	short					nFixedCategory;
//STRIP001 
//STRIP001 	long					nCatHeight;
//STRIP001 
//STRIP001 	long					nCurFormatY;
//STRIP001 	long					nCurFormatHeight;
//STRIP001 	long					nStdFormatY;
//STRIP001 	long					nStdFormatHeight;
//STRIP001 	String					aStrEurope;
//STRIP001     String                  sAutomaticEntry;
//STRIP001             
//STRIP001 	Window*					pLastActivWindow;
//STRIP001 
//STRIP001 #ifdef _SVX_NUMFMT_CXX
//STRIP001 	void 	Init_Impl();
//STRIP001 	void	FillCurrencyBox();
//STRIP001 	void 	FillFormatListBox_Impl( SvxDelStrgs& rEntries );
//STRIP001 	void 	UpdateOptions_Impl( BOOL bCheckCatChange );
//STRIP001 	void	UpdateFormatListBox_Impl( USHORT bCat, BOOL bUpdateEdit );
//STRIP001 	void	DeleteEntryList_Impl( SvxDelStrgs& rEntries );
//STRIP001 	void	Obstructing();
//STRIP001     void    EnableBySourceFormat_Impl();
//STRIP001 	void	SetCategory( USHORT nPos );
//STRIP001     String  GetExpColorString( Color*& rpPreviewColor, const String& aFormatStr, short nTmpCatPos );
//STRIP001     void    MakePreviewText( const String& rFormat );
//STRIP001     void    ChangePreviewText( USHORT nPos );
//STRIP001     void    AddAutomaticLanguage_Impl(LanguageType eAutoLang, BOOL bSelect);
//STRIP001 	// Handler
//STRIP001 	DECL_LINK( LostFocusHdl_Impl, Edit* pEd );
//STRIP001 	DECL_LINK( DoubleClickHdl_Impl, SvxFontListBox* pLb );
//STRIP001 	DECL_LINK( SelFormatHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickHdl_Impl, ImageButton* pIB );
//STRIP001 	DECL_LINK( EditHdl_Impl, Edit* pEdFormat );
//STRIP001 	DECL_LINK( OptHdl_Impl, void * );
//STRIP001 	DECL_LINK( TimeHdl_Impl, Timer * );
//STRIP001 
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif

